// conndoc.h : interface of the CConnectDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CConnectDoc;

#include "map.h"
#include "empobj.h"

class CConnectDoc : public CDocument
{
protected: // create from serialization only
	CConnectDoc();
	DECLARE_DYNCREATE(CConnectDoc)

// Attributes
public:
	int mdoc_MAXX;
	int mdoc_MAXY;
	int mdoc_ADJX;
	int mdoc_ADJY;
	int mdoc_S1;
	int mdoc_S2;
	int mdoc_S3;
	int mdoc_S4;
	CString mdoc_stringHost;		// hostname (or IP) of emp server
	CString mdoc_stringPort;		// port of emp server socket
	CString mdoc_stringUser;		// username to give at logon
	CString mdoc_stringCoun;		// country name to give
	CString mdoc_stringPass;		// password (Representative) to give
	CString mdoc_stringWavDefault;	// pathname to .WAV file for default sound
	CString mdoc_stringWavLogon;	
	CString mdoc_stringWavLogoff;	
	CString mdoc_stringWavOnFlashMsg;	
	CString mdoc_stringWavOnInformMsg;	
	UINT mdoc_nScrollBufferLines;
	CString mdoc_stringExecFilename;
	BOOL mdoc_bBeep;				// beep when inform/flash/asyncupdate msgs arrive
    BOOL mdoc_bOnline;
    BOOL mdoc_bSpecialRedraw;
    BOOL mdoc_bRightBClose;
    CEmpShipList mdoc_ShipList;
    CEmpPlaneList mdoc_PlaneList;
    CEmpLandList mdoc_LandList;
    CEmpNukeList mdoc_NukeList;
    CString mdoc_Macro1;
    CString mdoc_Macro2;    
    CString mdoc_Macro3;    
    CString mdoc_Macro4;    
    CString mdoc_Macro5;    
    CString mdoc_Macro6;    
    CString mdoc_Macro7;    
    CString mdoc_Macro8;    
    CString mdoc_Macro9;    
    CString mdoc_Macro10;    
    int mdoc_nLBFontHeight;
    int mdoc_nLBHeight;
    int mdoc_nLBWidth;
    int mdoc_nPointSize; // for printer
    CString mdoc_stringAuxFilename;
    

public:
	Cmap *db[MAX_CMAP];	// hard-coded for 64x64 world
	int mdoc_nZoom;
	int mdoc_nS1;
	int mdoc_nS2;	
	int mdoc_nS3;	
	int mdoc_nS4;
	
	BOOL mdoc_bShowHighlight;	
    BOOL mdoc_bShowMapChar;
    BOOL mdoc_bShowDist;
    BOOL mdoc_bShowShips;    
    BOOL mdoc_bShowPlanes;    
    BOOL mdoc_bShowLand;    
    BOOL mdoc_bShowNukes;    
    BOOL mdoc_bShowMil;
    BOOL mdoc_bPrintHexGrid;
    
public:	
	Cmap *GetUserSect(coord x, coord y);
	Cmap *GetSysSect(coord x, coord y);
	void SetUserSectMapChar(coord x, coord y, u_char ucMapChar);
	void SetUserSectOwned(coord x, coord y, u_char ucOwned);
	void SetUserSectHighlighted(coord x, coord y, u_char ucHighlighted);
	
// Operations
public:

// Implementation
public:
	virtual ~CConnectDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual BOOL OnNewDocument();

// Generated message map functions
protected:
	//{{AFX_MSG(CConnectDoc)
	afx_msg void OnScrollBufferMenu();
	afx_msg void OnUpdateExecute(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHistory(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMapView(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRepeat(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
