// connvw.cpp : implementation of the CConnectView class
//

#include "stdafx.h" 
#include "mmsystem.h"
#include "wsempire.h"

#include "conndoc.h"
#include "connvw.h"
#include "hostdlg.h"
#include "fexecdlg.h"
#include "historyd.h"

#include "servpge.h"
#include "sounpge.h"
#include "genpge.h"
#include "macrpge.h"

#include <ctype.h>
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConnectView

IMPLEMENT_DYNCREATE(CConnectView, CFormView)

BEGIN_MESSAGE_MAP(CConnectView, CFormView)
	//{{AFX_MSG_MAP(CConnectView)
	ON_MESSAGE(WM_USER_ASYNC_HOST_LOOKUP, OnAsyncHostLookup)
	ON_MESSAGE(WM_USER_ASYNC_SELECT, OnAsyncSelect)
	ON_BN_CLICKED(IDC_CONNVIEW_SENDBUTTON, OnConnviewSendbutton)
	ON_BN_CLICKED(IDC_CONNVIEW_CONNECTBUTTON, OnConnviewConnectbutton)
	ON_BN_CLICKED(IDC_CONNVIEW_CAPTUREBUTTON, OnConnviewCapturebutton)
	ON_COMMAND(IDM_CLEARLB, OnClearLB)
	ON_COMMAND(IDM_EXECUTE, OnExecuteFile)	
	ON_COMMAND(IDM_REPEAT, OnRepeatPrevEmpCmd)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(IDM_LB_WIDER, OnLBWider)
	ON_COMMAND(IDM_LB_NARROWER, OnLBNarrower)	
	ON_COMMAND(IDM_LB_TALLER, OnLBTaller)	
	ON_COMMAND(IDM_LB_SHORTER, OnLBShorter)	
	ON_COMMAND(ID_EDIT_DESELECT_ALL, OnEditDeselectAll)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_COMMAND(IDM_HISTORY, OnHistory)
	ON_COMMAND(IDM_BEEP, OnBeep)
	ON_UPDATE_COMMAND_UI(IDM_BEEP, OnUpdateBeep)
	ON_COMMAND(IDM_DEBUG, OnDebug)
	ON_COMMAND(IDM_MACRO1, OnMacro1)
	ON_COMMAND(IDM_MACRO2, OnMacro2)
	ON_COMMAND(IDM_MACRO3, OnMacro3)
	ON_COMMAND(IDM_MACRO4, OnMacro4)
	ON_COMMAND(IDM_MACRO5, OnMacro5)
	ON_COMMAND(IDM_MACRO6, OnMacro6)
	ON_COMMAND(IDM_MACRO7, OnMacro7)
	ON_COMMAND(IDM_MACRO8, OnMacro8)
	ON_COMMAND(IDM_MACRO9, OnMacro9)
	ON_COMMAND(IDM_MACRO10, OnMacro10)
	ON_COMMAND(IDM_PREFERENCES, OnPreferences)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConnectView construction/destruction

CConnectView::CConnectView()
	: CFormView(CConnectView::IDD)
{
//	m_pdoc = NULL;			// init in OnInitialUpdate()
	m_s = INVALID_SOCKET;   // the socket for this doc/view
	m_hAsyncHost = 0;       // handle to async host lookup
	m_nConnState = CONN_STATE_DISCONNECTED;		// initial state
	m_nExpectSpecific = FALSE;	// looking for specific string
	m_bKillProc = FALSE;
	m_bLoggedOn = FALSE;
    
	m_stringPartial = "";	// holder of msg w/o newline
	m_nHavePartial = FALSE; // does holder have a piece?
		
	m_nBytesToSend = 0;
	m_nTotalBytesToSend = 0;
	m_SendBuf[0] = '\0';
	m_RecvBuf[0] = '\0';
	
//	m_nLBFontHeight = -1 * AfxGetApp()->GetProfileInt("Listbox", "FontHeight", 0);

	m_bAuxFile = FALSE;
//	m_stringAuxFilename = "wsempire.aux";
	
	m_bRedir = FALSE;   
	m_bPipe = FALSE;
	m_bExecute = FALSE;
    
//    m_nPointSize = AfxGetApp()->GetProfileInt("Printer", "FontSize", 10);
    
	m_stringPrevCmd = "";
	for(m_nLastHistory=0; m_nLastHistory<EMP_HISTORY_STRINGS; m_nLastHistory++)
		{
		m_stringHistory[m_nLastHistory] = "";
		}
	m_nLastHistory=0;
	m_nNewTeles = 0;	// from C_INFORM server messages
	        
	//{{AFX_DATA_INIT(CConnectView)
	m_stringCmd = "";
	//}}AFX_DATA_INIT
}
                                       
                                       
                                       
CConnectView::~CConnectView()
{
if( m_bAuxFile )
	{
	m_cstdiofileAuxFile.Close();
	m_bAuxFile = FALSE;
	}
if( m_bRedir )
	{
	m_RedirFile.Close();
	m_bRedir = FALSE;
	}
if( m_bPipe )
	{
	//m_PipeFile.Close();
	m_bPipe = FALSE;
	}
if( m_bExecute )
	{
	m_ExecuteFile.Close();
	m_bExecute = FALSE;
	}	
if( m_s != INVALID_SOCKET )
	{
	closesocket(m_s);
	m_s = INVALID_SOCKET;
	m_nConnState = CONN_STATE_DISCONNECTED;
	}
}



void CConnectView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectView)
	DDX_Text(pDX, IDC_CONNVIEW_CMD, m_stringCmd);
	//}}AFX_DATA_MAP
}



/////////////////////////////////////////////////////////////////////////////
// CConnectView printing
// Insert values in the Print dialog box, especially length of document
// Call DoPreparePrinting to display dialog box and create DC

BOOL CConnectView::OnPreparePrinting(CPrintInfo* pInfo)
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
int nItems;

if( pInfo == NULL )	// Can be null if DC will be for a screen?
	return( 0 );	// cancel the printing

nItems = plb->GetSelCount();	// How many lines are selected/highlighted
if( nItems == LB_ERR )
	nItems = 0;
if( nItems <= 0 )
	return( 0 );	// cancel the printing

pInfo->m_bContinuePrinting = TRUE;

return DoPreparePrinting(pInfo);	// default preparation
} /* end of OnPreparePrinting */



    
// This is specially overridden since we don't know how many pages
// are to be printed during OnPreparePrinting.  This is called for
// each page, and tests to see if we are done.    
void CConnectView::OnPrepareDC(CDC *pDC, CPrintInfo* pInfo = NULL)
{
CConnectDoc* pDoc = GetDocument();
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
CFont font;
RECT rect;
int nHeight, nLinesPerPage, nItems;
TEXTMETRIC tm;
int nPointSize = pDoc->mdoc_nPointSize;

if( pInfo != NULL )
	{
	pDC->SetMapMode(MM_TWIPS);
	rect = pInfo->m_rectDraw;
	pDC->DPtoLP(&rect);
	font.CreateFont( (-20 * nPointSize), 0, 0, 0, FW_BOLD, FALSE, FALSE,
		0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_MODERN, "Courier New");
	CFont *pOldFont = (CFont *)(pDC->SelectObject(&font));
	pDC->GetTextMetrics(&tm);
	nHeight = tm.tmHeight + tm.tmExternalLeading;
	nLinesPerPage = -(rect.bottom / nHeight);
	nLinesPerPage -= 3;	// for header + space at foot
	nItems = plb->GetSelCount();
//    if( ((nItems+1/nLinesPerPage)+1) < ((int)pInfo->m_nCurPage) )	
	if( (nItems+nLinesPerPage) <= ((int)pInfo->m_nCurPage * nLinesPerPage) )
		pInfo->m_bContinuePrinting = FALSE;
	else
		pInfo->m_bContinuePrinting = TRUE;	
	pDC->SelectObject(pOldFont);
	}
// has to be after the other code...
CFormView::OnPrepareDC(pDC, pInfo);
// then rechecked after OnPrepareDC base class
if( pInfo != NULL )
	{
//    if( ((nItems+1/nLinesPerPage)+1) < ((int)pInfo->m_nCurPage) )	
	if( (nItems+nLinesPerPage) <= ((int)pInfo->m_nCurPage * nLinesPerPage) )
		pInfo->m_bContinuePrinting = FALSE;
	else
		pInfo->m_bContinuePrinting = TRUE;
	}
}

//
// Set length of document based on DC if not set already
// Allocate & set various GDI resources
//
void CConnectView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
}

//
// Deallocate resources and clean up after printing
//
void CConnectView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
}

//
// This function asks us to draw page # m_nCurPage
// Print headers, footers, etc.
// would call OnDraw if was a WYSIWYG application.
// Use m_rectDraw for the printable area. Adjust this if doing header/footer
// Select any GDI objects each time in this function.
// p340 Inside VC++

void CConnectView::OnPrint(CDC* pDC, CPrintInfo *pInfo)
{
CConnectDoc* pDoc = GetDocument();
CPoint point;
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
int nSelList[500];
int *nPtr;
int i, nSelected;
int nPage, nStartLine, nEndLine;
int nLinesPerPage, nHeight, nHgt;
CString s;
CFont font;
CFont fontH;              
TEXTMETRIC tm;
int nPointSize = pDoc->mdoc_nPointSize;
RECT rect;
char str[80];

if( pInfo == NULL )
	return;               
	
pDC->SetMapMode(MM_TWIPS);
//wsprintf(str,"%d %d %d %d",pInfo->m_rectDraw.left, pInfo->m_rectDraw.top, pInfo->m_rectDraw.right, pInfo->m_rectDraw.bottom);
rect = pInfo->m_rectDraw;
pDC->DPtoLP(&rect);                          
//wsprintf(str2,"%d %d %d %d",rect.left, rect.top, rect.right, rect.bottom);
                                                    
fontH.CreateFont( (-20 * nPointSize), 0, 0, 0, FW_BOLD, FALSE, FALSE,
	0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
	CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
	DEFAULT_PITCH | FF_MODERN, "Courier New");
CFont *pOldFont = (CFont *)(pDC->SelectObject(&fontH));
pDC->GetTextMetrics(&tm);
nHeight = tm.tmHeight + tm.tmExternalLeading;
nHgt = tm.tmHeight;

// Figure lines per page, minus 2 used for header.
nLinesPerPage = -(rect.bottom / nHeight);
nLinesPerPage -= 3;	// for header + space at foot
nPage = pInfo->m_nCurPage;
nStartLine = (nPage - 1) * nLinesPerPage;
nEndLine = nStartLine + nLinesPerPage;
nPtr = &(nSelList[0]);          
nSelected = plb->GetSelItems( 500, nPtr );
if( nSelected < nEndLine )
	nEndLine = nSelected;
	
// page header 
pDC->Rectangle(rect.left, rect.top, rect.right, (rect.top - (2 * nHgt)));
s = "WS Empire Client v2.0";
pDC->SetTextAlign(TA_CENTER);
pDC->TextOut(rect.right / 2, -(nHgt / 2), s);
wsprintf(str,"%d,%d,%d Page %d",nStartLine,nEndLine,nSelected,nPage);
pDC->SetTextAlign(TA_RIGHT);                             
pDC->TextOut(rect.right - 720, -(nHgt / 2), str, strlen(str));

font.CreateFont( (-20 * nPointSize), 0, 0, 0, 400, FALSE, FALSE,
	0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
	CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
	DEFAULT_PITCH | FF_MODERN, "Courier New");
pDC->SelectObject(&font);

point.x = pInfo->m_rectDraw.left;
point.y = pInfo->m_rectDraw.top - (3 * nHgt);
//point.y = pInfo->m_rectDraw.top - (2 * nHeight); trying to avoid hitting rect box

// page body
pDC->SetTextAlign(TA_LEFT);	
for( i=nStartLine; i<nEndLine; i++)
	{
	plb->GetText(nSelList[i], s);
	pDC->TextOut(point.x, point.y, s, s.GetLength());
	point.y -= nHeight;
	}		
	
// page footer

// cleanup
pDC->SelectObject(pOldFont);

}

/////////////////////////////////////////////////////////////////////////////
// CConnectView diagnostics

#ifdef _DEBUG
void CConnectView::AssertValid() const
{
	CFormView::AssertValid();
}

void CConnectView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
	dc << "\nCConnectView JON was here";
}

CConnectDoc* CConnectView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CConnectDoc)));
	return (CConnectDoc*)m_pDocument;
}
#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////
// CConnectView message handlers

void CConnectView::OnInitialUpdate()
{
CConnectDoc* pDoc = GetDocument();
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
CRect rlb, rp;

GetWindowRect( &rp );
plb->GetWindowRect( &rlb );
plb->MoveWindow((rlb.left - rp.left - 1), (rlb.top - rp.top - 1), pDoc->mdoc_nLBWidth, pDoc->mdoc_nLBHeight, FALSE);

// -10 kind of small but is readable at ATD.
// -12 looks very nice at ATD!
if( pDoc->mdoc_nLBFontHeight )		// if a height is set, use it.
	{
	m_LBFont.CreateFont(pDoc->mdoc_nLBFontHeight, 0, 0, 0,
			FW_NORMAL, FALSE, FALSE, 0,
			ANSI_CHARSET, OUT_TT_PRECIS,
			CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
			FIXED_PITCH | FF_MODERN | TMPF_TRUETYPE, "Courier New");
	plb->SetFont(&m_LBFont);
	}

AddToListBox("-= WS Empire Client v2.0a4=-");
AddToListBox("-=   by Jonathan Butler   =-");
AddToListBox("-=   jonbutler@acm.org    =-",ATLB_SETCURSEL);
{
char s[80];
wsprintf(s,"debug: Cmap is %d bytes.",sizeof(Cmap));
AddToListBox(s,ATLB_SETCURSEL);
}

SetDlgItemText(IDC_CONNVIEW_STATUS,"Disconnected");
	
// Set focus to the connect button
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CONNECTBUTTON));

} /* end of CConnectView::OnInitialUpdate */


     
     
     
LONG CConnectView::OnAsyncHostLookup(WPARAM wParam, LPARAM lParam)
{
char lpszMessage[100];
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);

if( WSAGETASYNCERROR(lParam) != 0 )
	{
	wsprintf(lpszMessage, "AsyncGetHostByName return failed (Winsock error %d)",WSAGETASYNCERROR(lParam));
	m_nConnState = CONN_STATE_DISCONNECTED;
	SetDlgItemText(IDC_CONNVIEW_STATUS,"Disconnected");
	SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON, "Connect"); // rarely encountered
	ErrorBox(lpszMessage, WSAGETASYNCERROR(lParam));
	}
else
	{
	m_pHostEnt = (PHOSTENT)m_achHostEnt;
	memcpy(&m_in, m_pHostEnt->h_addr, 4);                                 
	wsprintf(lpszMessage,"Host %s has IP address %s", m_pHostEnt->h_name, inet_ntoa(m_in));
	m_nConnState = CONN_STATE_HAVEHOST;
	SetDlgItemText(IDC_CONNVIEW_STATUS,"Ready to Proceed with Connection");
	SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON, "Proceed"); // stops here waiting for go ahead with connection
	}
	
m_hAsyncHost = 0;							// clear out the handle for cancelling this command
AddToListBox(lpszMessage,ATLB_SETCURSEL);	// add the latest message to listbox

											// Set focus to the connect button
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CONNECTBUTTON));
	
return 0L;
} /* end of OnAsyncHostLookup */





void CConnectView::AddToListBox(CString s, BOOL bSetCurSel)
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
int lbret=0;

plb->SetSel(plb->GetCount() - 1, FALSE);
lbret = plb->InsertString(-1,s);			// add the latest message to listbox
if( lbret == LB_ERR || lbret == LB_ERRSPACE )
	ErrorBox("ListBox Error or Out of Space\nin AddToListBox()");
	
if( bSetCurSel ) /* OR mdoc_bAlwaysSetCurSel */
	plb->SetSel(plb->GetCount() - 1, TRUE);
} /* end of AddToListBox */




void CConnectView::AddToAuxFile(CString s)
{
s += "\n";	
m_cstdiofileAuxFile.WriteString(s);	// add this string to aux file.
} /* end of AddToAuxFile */



void CConnectView::AddToRedir(CString s)
{
s += "\n";
m_RedirFile.WriteString(s);	// add this string to file.
} /* end of AddToRedir */




void CConnectView::FailConnect(int n)
{                           
char str[30];
wsprintf(str,"%dConnect",n);
m_nExpectSpecific = 0;
m_nConnState = CONN_STATE_DISCONNECTED;
SetDlgItemText(IDC_CONNVIEW_STATUS,"Disconnected");
SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON, "Connect"); 
//SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON, str);
}



 
void CConnectView::ServerCmd( CString &s )
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
CConnectDoc* pDoc = GetDocument();
CString stringBuf;
char lpszMessage[50];
int nCode, nBtu, nMin, nDummy;
int nClientProto;
int i, c;
CString sectString;

sectString = s.Right(s.GetLength() - 2);	// Make a copy of the string so we have one for sect command
// with 8th bit set for highlight.

if( isalpha(s.GetAt(0)) )
	nCode = 10 + ( s.GetAt(0) - 'a' );
else
	nCode = s.GetAt(0) - '0';

nDummy = s.GetLength();
for(i=0; i<nDummy; i++)
	if( (c=s.GetAt(i)) < 0 )
		s.SetAt(i, (c + 128));
		
if( m_nExpectSpecific )
	{
	switch( m_nExpectSpecific )
		{                                            
		case READ_STATE_FIRSTSERVERINIT:
			stringBuf = s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( nCode == EMP_C_INIT )
				{				
				m_nExpectSpecific = READ_STATE_USERCMDOK;
				wsprintf(m_SendBuf, "user %s\n", pDoc->mdoc_stringUser);
				m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
				PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
				}
			else
				{
				FailConnect(1);
				ErrorBox("Received Wrong Code\nExpected: 2 Empire server ready");
				}
			break;
		case READ_STATE_USERCMDOK:
			stringBuf = s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( nCode == EMP_C_CMDOK )
				{				
				m_nExpectSpecific = READ_STATE_COUNCMDOK;
				wsprintf(m_SendBuf, "coun %s\n", pDoc->mdoc_stringCoun);
				m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
				PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
				}
			else
				{
				FailConnect(2);
				ErrorBox("Received Wrong Code\nExpected: 0 hello USER");
				}
			break;
		case READ_STATE_COUNCMDOK:
			stringBuf = s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( nCode == EMP_C_CMDOK )
				{				
				m_nExpectSpecific = READ_STATE_PASSCMDOK;
				wsprintf(m_SendBuf, "pass %s\n", pDoc->mdoc_stringPass);
				m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
				PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
				}
			else
				{
				FailConnect(3);
				ErrorBox("No Such Country\nExpected: 0 country name COUN");
				}
			break;
		case READ_STATE_PASSCMDOK:
			stringBuf = s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( nCode == EMP_C_CMDOK )
				{
				if( m_bKillProc )
					{
					m_nExpectSpecific = READ_STATE_KILLPROC;
					wsprintf(m_SendBuf, "kill\n");
					m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
					PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
					}
				else
					{				
					m_nExpectSpecific = READ_STATE_PLAYINIT;
					wsprintf(m_SendBuf, "play\n");
					m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
					PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
					}
				}
			else            
				{
				FailConnect(4);
				ErrorBox("Bad Password\nExpected: 0 password ok");
				}
			break;
		case READ_STATE_KILLPROC:
			stringBuf = "Empire Server returned:\n" + s;
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			FailConnect(5);
			m_nExpectSpecific = 0;
			break;
		case READ_STATE_PLAYINIT:
			if( nCode == EMP_C_INIT )
				{
				m_nExpectSpecific = 0;
				// see if next arg matches this CLIENTPROTO
				nClientProto = s.GetAt(2) - '0';
				if( nClientProto != EMP_CLIENT_PROTO )
					{
					wsprintf(lpszMessage,"Warning: Got Client Proto = %d; expected %d",nClientProto, (int)EMP_CLIENT_PROTO);
					MessageBox(lpszMessage,"Warning");
					}
				SetDlgItemText(IDC_CONNVIEW_STATUS,"Empire is Ready");
				SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON,"Disconnect");
				AddToListBox("-=O=-",ATLB_SETCURSEL);
				m_bLoggedOn = TRUE;
				pDoc->mdoc_bOnline = TRUE;
				if( pDoc->mdoc_bBeep )
					sndPlaySound(pDoc->mdoc_stringWavLogon, SND_ASYNC);
					//MessageBeep(MB_ICONEXCLAMATION);				
				}
			else
				{
				AddToListBox(s,ATLB_SETCURSEL);
				FailConnect(6);
				ErrorBox("Received Wrong Code\nExpected: 2 CLIENTPROTO");
				}
			break;
		} /* end of m_nExpectSpecific nCode switch */
	}
else
	{
	switch( nCode )
		{
		case EMP_C_DATA:
			stringBuf = s.Right(s.GetLength() - 2);
			if( m_bAuxFile )
				AddToAuxFile(stringBuf);
			if( m_bRedir )
				AddToRedir(stringBuf);
			else if( m_bPipe )
				AddToPipe(stringBuf, sectString);	// NOTE: special string passed here!!!!
			else
				AddToListBox(stringBuf);				
			break;                    
		case EMP_C_PROMPT:
			sscanf(s, "%d %d %d", &nDummy, &nMin, &nBtu);		// parse out the prompt info
			wsprintf(lpszMessage,"[%d:%d]", nMin, nBtu);        // format for dialog static text
			SetDlgItemText(IDC_CONNVIEW_BTU,lpszMessage);       // set [min:btu] to new value
			if( m_nNewTeles==0 )
				wsprintf(lpszMessage,"[%d:%d] Command:", nMin, nBtu); // format for view's listbox
			else
				{
				if( m_nNewTeles == 1 )
					wsprintf(lpszMessage,"[New Tele][%d:%d] Command:", nMin, nBtu); // format for view's listbox
				else
					wsprintf(lpszMessage,"[%d New Teles][%d:%d] Command:", m_nNewTeles, nMin, nBtu); // format for view's listbox
				}
			
			AddToListBox("");								// blank line first for spacing
			AddToListBox(lpszMessage,ATLB_SETCURSEL);
			if( m_bAuxFile )
				{
				AddToAuxFile("");
				AddToAuxFile(lpszMessage);
				}
			if( m_bRedir )
				{                
				m_RedirFile.Close();
				m_bRedir = FALSE;
				}
			if( m_bPipe )
				{               
				//m_PipeFile.Close();
				m_bPipe = FALSE;
				}                
			if( m_bExecute )
				{
				m_ExecuteFile.Close();
				m_bExecute = FALSE;
				}
			break;
		case EMP_C_FLASH:
			stringBuf = s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( pDoc->mdoc_bBeep )
				sndPlaySound(pDoc->mdoc_stringWavOnFlashMsg, SND_ASYNC);
				//MessageBeep(MB_ICONEXCLAMATION);
			break;
		case EMP_C_INFORM:
			if( s.GetLength() == 2 )	// "e " is empty indication
				m_nNewTeles = 0;
			else if( s[3]=='n' )		// "e [new tele]"
				m_nNewTeles = 1;
			else
				{
				stringBuf = s.Right(s.GetLength() - 3); 
				m_nNewTeles = atoi(stringBuf);	// "e [17 new teles]"
				}
			if( m_nNewTeles > 0 )                      
				{
				stringBuf = s.Right(s.GetLength() - 2);
				AddToListBox(stringBuf,ATLB_SETCURSEL);
				if( pDoc->mdoc_bBeep )
					sndPlaySound(pDoc->mdoc_stringWavOnInformMsg, SND_ASYNC);
					//MessageBeep(MB_ICONEXCLAMATION);		
				}
			break;
		case EMP_C_FLUSH:
			stringBuf = s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( m_bAuxFile )
				AddToAuxFile(stringBuf);
			break;
		case EMP_C_ABORT:
			stringBuf = "Aborted: " + s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( m_bAuxFile )
				AddToAuxFile(stringBuf);
			if( m_bRedir )
				AddToRedir(stringBuf);
			break;
		case EMP_C_CMDERR:
		case EMP_C_BADCMD:
			stringBuf = "Error; " + s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( m_bAuxFile )			
				AddToAuxFile(stringBuf);
			if( m_bRedir )
				AddToRedir(stringBuf);							
			break;				
		case EMP_C_EXIT:
			stringBuf = "Exit: " + s.Right(s.GetLength() - 2);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( m_bAuxFile )			
				AddToAuxFile(stringBuf);
			if( m_bRedir )
				AddToRedir(stringBuf);				
			m_bLoggedOn = FALSE;
			pDoc->mdoc_bOnline = FALSE;							
			break;       
		case EMP_C_REDIR:
			stringBuf = s.Right(s.GetLength() - 2);
			DoRedir(stringBuf);
			break;		
		case EMP_C_EXECUTE:    
			stringBuf = s.Right(s.GetLength() - 2);		
			DoExecute(stringBuf);
			break;
		case EMP_C_PIPE:
			stringBuf = s.Right(s.GetLength() - 2);		
			DoPipe(stringBuf);
			break;
		default:                                 
			//stringBuf = s.Right(s.GetLength() - 0); for looking at the nCode value		
			stringBuf = s.Right(s.GetLength() - 0);
			AddToListBox(stringBuf,ATLB_SETCURSEL);
			if( m_bAuxFile )			
				AddToAuxFile(stringBuf);
			if( m_bRedir )
				AddToRedir(stringBuf);
			if( m_bPipe )
				AddToPipe(stringBuf, sectString);								
			break;
		} /* end of switch */
	}

} /* end of ServerCmd */





void CConnectView::DoPipe(CString s)
{
CString stringName;
int i;

if( m_bPipe )
	{
	//m_RedirFile.Close();	// close the already open file
	// Seeing a pipe cmd when in one could mean a goof...
	m_bPipe = FALSE;       // reset flag to false in case we fail below
	}                

					// "| map"
i = 1;              // get filename: skipping whitespace
while( s[i] && s[i]==' ')
	i++;

stringName = s.Right(s.GetLength() - i);
if( stringName.IsEmpty() )
	m_bPipe = 0;
else
	stringName.MakeLower();

// Use least number of letters available so as to be non-ambiguous	
if( stringName.Find("map") > (-1) )
	{ m_bPipe = 1; m_nParseType = PARSE_MAP; m_nParseMode = 1; }
if( stringName.Find("sec") > (-1) )
	{ m_bPipe = 1; m_nParseType = PARSE_SECT; m_nParseMode = 1; }
if( stringName.Find("cen") > (-1) )
	{ m_bPipe = 1; m_nParseType = PARSE_CEN; m_nParseMode = 1; }
if( stringName.Find("du") > (-1) )
	{ m_bPipe = 1; m_nParseType = PARSE_DUMP; m_nParseMode = 1; }
if( stringName.Find("sh") > (-1) )
	{ m_bPipe = 1; m_nParseType = PARSE_SHIP; m_nParseMode = 1; }	
if( stringName.Find("pla") > (-1) )
	{ m_bPipe = 1; m_nParseType = PARSE_PLANE; m_nParseMode = 1; }	
if( stringName[0]=='l' && stringName[1]=='a' )
	{ m_bPipe = 1; m_nParseType = PARSE_LAND; m_nParseMode = 1; }	// "la" is found within "pla"	
if( stringName.Find("nu") > (-1) )
	{ m_bPipe = 1; m_nParseType = PARSE_NUKE; m_nParseMode = 1; }	
if( !m_bPipe )
	{
	AddToListBox("Pipe to Parser failed!",ATLB_SETCURSEL);
	}     
} /* end of DoPipe */





void CConnectView::AddToPipe(CString s, CString s2)
{

if( m_nParseMode == 1 )		// This is the first line of server pipe output
	{
	m_nParseMode = 2;		// We skip the command redisplay
	return;					// "map 0,0 | map"
	}
// mode 2 is 1st part (or all) of output data
	
switch( m_nParseType )
	{
	case PARSE_MAP:
		ParseMap(s);
		break;
	case PARSE_SECT:
		ParseSect(s, s2);
		break;
	case PARSE_CEN:
		ParseCen(s);
		break;
	case PARSE_DUMP:
		ParseDump(s);
		break;		
	case PARSE_SHIP:
		ParseShip(s);
		break;
	case PARSE_LAND:
		ParseLand(s);
		break;
	case PARSE_PLANE:
		ParsePlane(s);
		break;
	case PARSE_NUKE:
		ParseNuke(s);
		break;						
	default:
		break;
	} /* end of switch */
	
} /* end of AddToPipe */
                      
                      


// This will WRONGLY interpret map -1,-1 as [1,1] since map is only 1 unit wide
// - set only MapChar, since this can be used for bmap as well.
// - do not set owner, since this shown sectors we do not own; water, mtn, etc.
// - exception: ? sectors are owned by someone else.
//
void CConnectView::ParseMap( CString s )
{
CConnectDoc* pDoc = GetDocument();                             
//char str[80];
int y, i, len;

switch( m_nParseMode )
	{
	case 2: // 1st line of header
		for(i=0; i<MAX_HEADER_LEN; i++)		// zero out the X coordinate array
			m_nXCoord[i] = 0;
		len = s.GetLength();
		for(i=5; i<len; i++)
			{
			if( s[i]=='-' )
				continue;
			else
				m_nXCoord[i] = 10 * (s[i] - '0');
			}
		m_nParseMode = 3;
		return;
		break;
	case 3: // 2nd line of header
	    m_nParseLen = len = s.GetLength();
	    for( i=5; i<len; i++)
	    	{
	    	m_nXCoord[i] += (s[i] - '0');
	    	if( m_nXCoord[i-1] > m_nXCoord[i] )
	    		m_nXCoord[i-1] *= (-1);
	    	}
	    if( len > 6 )
	    	if( abs(m_nXCoord[len-2]) > m_nXCoord[len-1] )
	    		m_nXCoord[len-1] *= (-1);
	    m_nParseMode = 4;
	    return;
		break;
	case 4: // body of map (or detect next-to-last header)
		if( s[3] == ' ' )
			m_nParseMode = 5;
		else
			{
			y = atoi(s);
			len = m_nParseLen;
	    	for( i=5; i<len; i++)
	    		{
	    		if( s[i] != ' ' )
	    			{
	    			pDoc->SetUserSectMapChar(m_nXCoord[i], y, s[i]);                       
	    			if( s[i]=='?' )
	    				pDoc->SetUserSectOwned(m_nXCoord[i], y, MAP_OWNED_OTHER);
//wsprintf(str,"[%d,%d,%c -> %d,%d,%c]",m_nXCoord[i],y,s[i],m->cSysX,m->cSysY,m->cMapChar);
//AddToListBox(str);                                         
	    			}
	    		} // end of for
			} // end of else
		return;
		break;
	case 5: // expect last header line
		m_nParseMode = 6;
		return;
		break;
	case 6: // junk following map?
		m_nParseMode = 0;
		return;
		break;
	default:
		break;
	} /* end of switch */
	
} /* end of ParseMap */







// This will WRONGLY interpret sect -1,-1 as [1,1] since sect is only 1 unit wide 
//
// Diff in map and sect:
//  loops start at 4 not 5
//  test s[2] not s[3]
//  look for len > 5 not 6
// 
void CConnectView::ParseSect( CString s, CString s2 )
{
CConnectDoc* pDoc = GetDocument();                             
//char str[80];
int y, i, len;

switch( m_nParseMode )
	{
	case 2: // 1st line of header
		for(i=0; i<MAX_HEADER_LEN; i++)		// zero out the X coordinate array
			m_nXCoord[i] = 0;
		len = s.GetLength();
		for(i=4; i<len; i++)
			{
			if( s[i]=='-' )
				continue;
			else
				m_nXCoord[i] = 10 * (s[i] - '0');
			}
		m_nParseMode = 3;
		return;
		break;
	case 3: // 2nd line of header
	    m_nParseLen = len = s.GetLength();
	    for(i=4; i<len; i++)
	    	{
	    	m_nXCoord[i] += (s[i] - '0');
	    	if( m_nXCoord[i-1] > m_nXCoord[i] )
	    		m_nXCoord[i-1] *= (-1);
	    	}
	    if( len > 5 )
	    	if( abs(m_nXCoord[len-2]) > m_nXCoord[len-1] )
	    		m_nXCoord[len-1] *= (-1);
	    m_nParseMode = 4;
//wsprintf(str,"s %d  s2 %d",s.GetLength(),s2.GetLength());	 
//AddToListBox(str);	    
	    return;
		break;
	case 4: // body of map (or detect next-to-last header)
		if( s[2] == ' ' )
			{ m_nParseMode = 5; }
		else
			{
			y = atoi(s);
			len = m_nParseLen;
	    	for( i=4; i<len; i++)
	    		{
	    		if( s[i] != ' ' )
	    			{
	    			if( s2[i] & 0x80 )
	    				pDoc->SetUserSectHighlighted(m_nXCoord[i], y, TRUE);
	    			pDoc->SetUserSectOwned(m_nXCoord[i], y, (char)MAP_OWNED_YOU);
	    			pDoc->SetUserSectMapChar(m_nXCoord[i], y, s[i]);
//Cmap *m = pDoc->GetUserSect(m_nXCoord[i], y);                           
//wsprintf(str,"[%d,%d,%c -> %d,%d,%c,%d,%d]",m_nXCoord[i],y,s[i],m->cSysX,m->cSysY,m->cMapChar,(int)m->cOwned,(int)s2[i]);
//AddToListBox(str);                                         
	    			}
	    		} // end of for
			} // end of else
		return;
		break;
	case 5: // expect last header line
		m_nParseMode = 6;
		return;
		break;
	case 6: // junk following map?
		m_nParseMode = 0;
		return;
		break;
	default:
		break;
	} /* end of switch */
	
} /* end of ParseSect */





void CConnectView::ParseCen( CString s )
{
CConnectDoc* pDoc = GetDocument();                             
//char str[80];
CString stringBuf;
Cmap *sct;
coord x, y;
int i, len;
static BOOL bCenGod;

switch( m_nParseMode )
	{
	case 2: // 1st line of header (The date)
		m_nParseMode = 3;
		return;
		break;
	case 3: // 2nd line of header (CENSUS ... del dst)
	    m_nParseMode = 4;
	    return;
		break;
	case 4: // 
	    m_nParseMode = 5;
	    if( s.Find("own ") != (-1) )
			bCenGod = TRUE;
		else
			bCenGod = FALSE;
	    return;
		break;	
	case 5: // body of census (or detect last header)
		if( s[0] != ' ' )
			{
			MarkSectWithMil(pDoc);
			m_nParseMode = 6;
			}
		else
			{
			if( bCenGod )
				{
				CString tmpString = s.Right(s.GetLength() - 4);
				s = tmpString;
				}
			x = atoi(s);
			i=0;
			len = s.GetLength();
			while( s[i] != ',' )
				i++;
			stringBuf = s.Right(len - (i+1));
			y = atoi(stringBuf);
			//wsprintf(str,"%hd,%hd",x,y);
			//AfxMessageBox(str);
			sct = pDoc->GetUserSect(x,y);
			if( (sct!=(Cmap *)(-1)) && (sct!=(Cmap *)0) )
				{                     
				stringBuf = s.Right(len - 13);
				sct->ucEff = atoi(stringBuf);
				stringBuf = s.Right(len - 22);
				sct->ucMob = atoi(stringBuf);				
				stringBuf = s.Right(len - 34);
				sct->unCiv = atoi(stringBuf);				
				stringBuf = s.Right(len - 39);
				sct->unMil = atoi(stringBuf);				
				stringBuf = s.Right(len - 49);
				sct->unFood= atoi(stringBuf);				
				} // end of sct != bad
			} // end of else
		return;
		break;
	case 6: // junk following cen?
		m_nParseMode = 0;
		return;
		break;
	default:
		break;
	} /* end of switch */
	
} /* end of ParseCen */




int bustline(char *str, char *BLptrarray[], int delim)
{
char *p;
int i;

if( str==NULL || *str=='\0' )		/* check for NULL string or */
	return(0);			/* empty string. */

//ASSERT( delim > 0 );

i=0;
while ( (p=_fstrchr(str,delim)) != NULL )	/* delimiter found */
	{
	BLptrarray[i++] = str;
	*p = '\0';
	p++;
	str = p;
	}

BLptrarray[i++] = str;		/* deal with final field for this line */

while(*str!= '\0')
	{
	if((*str == '\n')||(*str == '\r'))
		*str ='\0';
	str++;
	}

return(i);

} /* end of bustline */








void CConnectView::ParseDump( CString s )
{
CConnectDoc* pDoc = GetDocument();                             
CString stringBuf;
Cmap *sct;
coord x, y;
static BOOL bDumpGod;

switch( m_nParseMode )
	{
	case 2: // 1st line of header (The date)
		m_nParseMode = 3;
		return;
		break;
	case 3: // 2nd line of header (DUMP SECTOR)
	    m_nParseMode = 4;
	    return;
		break;
	case 4: // description line
	    m_nParseMode = 5;
	    if( s.Find("own ") != (-1) )
			bDumpGod = TRUE;
		else
			bDumpGod = FALSE;
	    return;
		break;	
	case 5: // body of census (or detect last header)
		{
		char *BLptrarray[100];
		char str[1024];
		int dg;
		if( bDumpGod )
			dg=1;
		else
			dg=0;
		_fstrcpy(str,s);				// make copy of CString
		bustline(str, BLptrarray, ' ');	// bust it up into fields
		if( BLptrarray[1][0] == 's' )	// if done with dump output; no dg adjustment
			{
			MarkSectWithDist(pDoc);
			MarkSectWithMil(pDoc);
			m_nParseMode = 6;
			}
		else
			{
			x = atoi(BLptrarray[0+dg]);	// x 0
			y = atoi(BLptrarray[1+dg]);	// y 1
			sct = pDoc->GetUserSect(x,y);
			if( (sct!=(Cmap *)(-1)) && (sct!=(Cmap *)0) )
				{
	    		pDoc->SetUserSectOwned(x, y, MAP_OWNED_YOU);	// if here, we own it
	    		pDoc->SetUserSectMapChar(x, y, BLptrarray[2+dg][0]);	// des 2
				sct->ucNewDes =			BLptrarray[3+dg][0];    // sdes 3
				sct->ucEff =			atoi(BLptrarray[4+dg]); // eff 4				
				sct->ucMob =			atoi(BLptrarray[5+dg]); // mob 5
				sct->ucOccupied =		atoi(BLptrarray[6+dg]); // * 6
				sct->ucProdOff =		atoi(BLptrarray[7+dg]); // off 7
				sct->ucMinContent =		atoi(BLptrarray[8+dg]); // min 8
				sct->ucGoldContent =	atoi(BLptrarray[9+dg]); // gold 9
				sct->ucFert =			atoi(BLptrarray[10+dg]); // fert 10
				sct->ucOilContent =		atoi(BLptrarray[11+dg]); // ocontent 11
				sct->ucUranContent =	atoi(BLptrarray[12+dg]); // uran 12
				sct->ucWork =			atoi(BLptrarray[13+dg]); // work 13
				sct->hnAvail =			atoi(BLptrarray[14+dg]); // avail 14
				sct->ucTerr =			atoi(BLptrarray[15+dg]); // terr 15
				sct->unCiv =			atoi(BLptrarray[16+dg]); // civ 16				
				sct->unMil =			atoi(BLptrarray[17+dg]); // mil 17
				sct->unUW =				atoi(BLptrarray[18+dg]); // uw 18				
				sct->unFood =			atoi(BLptrarray[19+dg]); // food 19
				sct->unShells =			atoi(BLptrarray[20+dg]);
				sct->unGuns =			atoi(BLptrarray[21+dg]);
				sct->unPetrol =			atoi(BLptrarray[22+dg]);
				sct->unIron =			atoi(BLptrarray[23+dg]);
				sct->unDust =			atoi(BLptrarray[24+dg]);
				sct->unBars =			atoi(BLptrarray[25+dg]);
				sct->unOil =			atoi(BLptrarray[26+dg]);
				sct->unLcm =			atoi(BLptrarray[27+dg]);
				sct->unHcm =			atoi(BLptrarray[28+dg]);
				sct->unRads =			atoi(BLptrarray[29+dg]);
								
				sct->coDistX =			atoi(BLptrarray[54+dg]); // dist_x 54				
				sct->coDistY =			atoi(BLptrarray[55+dg]); // dist_y 55
				sct->unCdist =			atoi(BLptrarray[56+dg]); // c_dist
				sct->unMdist =			atoi(BLptrarray[57+dg]); // m_dist
				sct->unUdist =			atoi(BLptrarray[58+dg]); // u_dist
				sct->unFdist =			atoi(BLptrarray[59+dg]); // f_dist
				sct->unSdist =			atoi(BLptrarray[60+dg]); // s_dist
				sct->unGdist =			atoi(BLptrarray[61+dg]); // g_dist
				sct->unPdist =			atoi(BLptrarray[62+dg]); // p_dist
				sct->unIdist =			atoi(BLptrarray[63+dg]); // i_dist
				sct->unDdist =			atoi(BLptrarray[64+dg]); // d_dist
				sct->unBdist =			atoi(BLptrarray[65+dg]); // b_dist
				sct->unOdist =			atoi(BLptrarray[66+dg]); // o_dist
				sct->unLdist =			atoi(BLptrarray[67+dg]); // l_dist
				sct->unHdist =			atoi(BLptrarray[68+dg]); // h_dist
				sct->unRdist =			atoi(BLptrarray[69+dg]); // r_dist
				} // end of got a good sct
			} // end of processing a dump line
		}
		return;
		break;
	case 6: // junk following dump?
		m_nParseMode = 0;
		return;
		break;
	default:
		break;
	} /* end of switch */
	
} /* end of ParseDump */




void CConnectView::ParseShip( CString s )
{
CConnectDoc* pDoc = GetDocument();                             
CEmpShip *pship;
static CEmpShip *pprevship;
static BOOL bShipFuel;
static BOOL bShipGod;

switch( m_nParseMode )
	{
	case 2: // 1st line of header (column headings)
		if( s.Find("No ship") != (-1) ) // See if this country has no ships.
			m_nParseMode = 0; // has none, so forget the pipe.
		else 
			{ // Is " fuel" in the header, set FUEL is defined
			if( s.Find(" fuel") != (-1) )
				bShipFuel = TRUE;
			else
				bShipFuel = FALSE;
			if( s.Find("own ") != (-1) )
				bShipGod = TRUE;
			else
				bShipGod = FALSE;
					// Reset the ship data structs to empty
			POSITION pos = pDoc->mdoc_ShipList.GetHeadPosition();
			while( pos != NULL )
				delete pDoc->mdoc_ShipList.GetNext( pos );
			pDoc->mdoc_ShipList.RemoveAll();	
			m_nParseMode = 3;
			}
		return;
		break;
	case 3: // body of ship report (or detect last header)
		if( s.Find("       ")==0 ) // Are 1st seven chars spaces?, then this is a shipname line.
			{ // this is a shipname
			pprevship->sShipname = s.Right(s.GetLength() - 7);
			}
		else if( s.GetLength() < 15 ) // look for "%d ship%s\n" N , splur
			{
			MarkSectWithShip(pDoc);
			m_nParseMode = 4;
			}
		else
			{ // a normal ship report line                  
			if( bShipGod )
				{
				CString tmpString = s.Right(s.GetLength() - 4);
				s = tmpString;
				}
            pship = new CEmpShip;
			pship->unNum = atoi(s.Mid(0,4));
			pship->sType = s.Mid(5,16);
			pship->coUserX = atoi(s.Mid(22,4));
			pship->coUserY = atoi(s.Mid(27,4));
			pship->ucMembership = s[32];
			pship->ucEff = atoi(s.Mid(33,4));			
			pship->unCiv = atoi(s.Mid(38,4));			
			pship->unMil = atoi(s.Mid(42,4));
			pship->unUW = atoi(s.Mid(46,4));
			pship->unFood = atoi(s.Mid(50,4));
			pship->ucPlanes = atoi(s.Mid(54,3));
			pship->ucHelis = atoi(s.Mid(57,3));
			pship->ucXlights = atoi(s.Mid(60,3));
			pship->ucLands = atoi(s.Mid(63,3));
			pship->ucMob = atoi(s.Mid(66,4));
			if( bShipFuel )
				{
				pship->unFuel = atoi(s.Mid(70,5));
				pship->unTech = atoi(s.Mid(75,4));
				}
			else
				{
				pship->unTech = atoi(s.Mid(70,4));
				}
			pDoc->mdoc_ShipList.AddHeadShip( pship );
			pprevship = pship;
			}		
		return;
		break;
	case 4: // junk following ship report?
		m_nParseMode = 0;
		return;
		break;
	default:
		break;
	} /* end of switch */
} // end of ParseShip 






void CConnectView::ParsePlane( CString s )
{
CConnectDoc* pDoc = GetDocument();                             
CEmpPlane *pplane;
static BOOL bOrbit;
static BOOL bPlaneGod;

switch( m_nParseMode )
	{
	case 2: // 1st line of header (column headings)
		if( s.Find("No plane") != (-1) ) // See if this country has no planes.
			m_nParseMode = 0; // has none, so forget the pipe.
		else 
			{ // Is " L S " in the header, set ORBIT is defined
			if( s.Find(" L S ") != (-1) )
				bOrbit = TRUE;
			else
				bOrbit = FALSE;
			if( s.Find("own ") != (-1) )
				bPlaneGod = TRUE;
			else
				bPlaneGod = FALSE;
					// Reset the plane data structs to empty
			POSITION pos = pDoc->mdoc_PlaneList.GetHeadPosition();
			while( pos != NULL )
				delete pDoc->mdoc_PlaneList.GetNext( pos );
			pDoc->mdoc_PlaneList.RemoveAll();	
			m_nParseMode = 3;
			}
		return;
		break;
	case 3: // body of plane report (or detect last header)
		if( s.GetLength() < 15 ) // look for "%d plane%s\n" N , splur
			{
			MarkSectWithPlane(pDoc);
			m_nParseMode = 4;
			}
		else
			{ // a normal plane report line
			if( bPlaneGod )
				{
				CString tmpString = s.Right(s.GetLength() - 4);
				s = tmpString;
				}                  
            pplane = new CEmpPlane;
			pplane->unNum = atoi(s.Mid(0,4));
			pplane->sType = s.Mid(5,19);	
			pplane->coUserX = atoi(s.Mid(25,4));
			pplane->coUserY = atoi(s.Mid(30,4));
			pplane->ucMembership = s[35];
			pplane->ucEff = atoi(s.Mid(37,3));			
			pplane->ucMob = atoi(s.Mid(42,3));
			pplane->ucAtt = atoi(s.Mid(46,3));			
			pplane->ucDef = atoi(s.Mid(50,3));
			pplane->unTech = atoi(s.Mid(55,3));
			pplane->ucRange = atoi(s.Mid(59,3));
			pplane->ucHard = atoi(s.Mid(64,3));
			if( s[71] != ' ' )
				{ // then we have a unit transporting this
				pplane->unCarryUnit = atoi(s.Mid(67,5));
				pplane->ucCarryType = s[72];
				if( bOrbit )
					{ // carry + orbit
					pplane->ucLaunched = s[74];
					pplane->ucSync = s[76];
					pplane->ucNukeAmt = atoi(s.Mid(78,1));
					pplane->sNukeType = s.Mid(80,9);
					}
				else
					{ // carry + !orbit
					pplane->ucLaunched = 0;
					pplane->ucSync = 0;					
					pplane->ucNukeAmt = atoi(s.Mid(74,1));
					pplane->sNukeType = s.Mid(76,9);
					}				
				}
			else
				{ // no transporting of this unit
				pplane->unCarryUnit = 0;
				pplane->ucCarryType = 0;
				if( bOrbit )
					{ // !carry + orbit
					pplane->ucLaunched = s[73];
					pplane->ucSync = s[75];
					pplane->ucNukeAmt = atoi(s.Mid(77,1));
					pplane->sNukeType = s.Mid(79,9);
					}
				else
					{ // !carry + !orbit
					pplane->ucLaunched = 0;
					pplane->ucSync = 0;					
					pplane->ucNukeAmt = atoi(s.Mid(73,1));
					pplane->sNukeType = s.Mid(75,9);
					}
				}
			pDoc->mdoc_PlaneList.AddHeadPlane( pplane );
			}		
		return;
		break;
	case 4: // junk following plane report?
		m_nParseMode = 0;
		return;
		break;
	default:
		break;
	} /* end of switch */
} // end of ParsePlane





void CConnectView::ParseLand( CString s )
{               
CConnectDoc* pDoc = GetDocument();                             
CEmpLand *pland;
static BOOL bFuel;
static BOOL bLandGod;

switch( m_nParseMode )
	{
	case 2: // 1st line of header (column headings)
		if( s.Find("No unit") != (-1) ) // See if this country has no land units.
			m_nParseMode = 0; // has none, so forget the pipe.
		else 
			{ // Is " fuel" in the header, set FUEL is defined
			if( s.Find(" fuel ") != (-1) )
				bFuel = TRUE;
			else
				bFuel = FALSE;
			if( s.Find("own ") != (-1) )
				bLandGod = TRUE;
			else
				bLandGod = FALSE;
					// Reset the land data structs to empty
			POSITION pos = pDoc->mdoc_LandList.GetHeadPosition();
			while( pos != NULL )
				delete pDoc->mdoc_LandList.GetNext( pos );
			pDoc->mdoc_LandList.RemoveAll();	
			m_nParseMode = 3;
			}
		return;
		break;
	case 3: // body of land report (or detect last header)
		if( s.GetLength() < 15 ) // look for "%d unit%s\n" N , splur
			{
			MarkSectWithLand(pDoc);
			m_nParseMode = 4;
			}
		else
			{ // a normal land report line
			if( bLandGod )
				{
				CString tmpString = s.Right(s.GetLength() - 4);
				s = tmpString;
				}                  
            pland = new CEmpLand;
			pland->unNum = atoi(s.Mid(0,4));
			pland->sType = s.Mid(5,16);			
			pland->coUserX = atoi(s.Mid(24,4));
			pland->coUserY = atoi(s.Mid(29,4));
			pland->ucMembership = s[33];
			pland->ucEff = atoi(s.Mid(34,4));			
			pland->ucFort = atoi(s.Mid(39,5));
			pland->ucMob = atoi(s.Mid(44,4));
			pland->unFood = atoi(s.Mid(48,5));
			if( bFuel )
				{
				pland->unFuel = atoi(s.Mid(53,5));
				pland->unTech = atoi(s.Mid(58,5));
				pland->ucRetreat = atoi(s.Mid(64,3));
				pland->ucRadius = atoi(s.Mid(68,4));
				pland->ucXlights = atoi(s.Mid(72,3));
				if( s.GetLength() > 78 )
					pland->unCarryShip = atoi(s.Mid(75,5));
				else
					pland->unCarryShip = 0;
				}
			else
				{
				pland->unTech = atoi(s.Mid(53,5));
				pland->ucRetreat = atoi(s.Mid(59,3));
				pland->ucRadius = atoi(s.Mid(63,4));
				pland->ucXlights = atoi(s.Mid(67,3));
				if( s.GetLength() > 73 )
					pland->unCarryShip = atoi(s.Mid(70,5));
				else
					pland->unCarryShip = 0;
				}
			pDoc->mdoc_LandList.AddHeadLand( pland );
			}		
		return;
		break;
	case 4: // junk following land report?
		m_nParseMode = 0;
		return;
		break;
	default:
		break;
	} /* end of switch */
} // end of ParseLand





void CConnectView::ParseNuke( CString s )
{                
m_nParseMode = 0;
}
 


 
void CConnectView::DoRedir(CString s)
{
CString stringFilename;
int RedirType;
int i;

if( m_bRedir )
	{
	m_RedirFile.Close();	// close the already open file
	m_bRedir = FALSE;       // reset flag to false in case we fail below
	}                


if( s.Find(">>") > -1 )     // get kind of redir
	RedirType = 2;          // append found
else
	RedirType = 1;          // must be > then.
	

i = RedirType;              // get filename: skipping whitespace
while( s[i] && s[i]==' ')
	i++;

stringFilename = s.Right(s.GetLength() - i);
if( stringFilename.IsEmpty() )
	RedirType = 0;

if( RedirType == 1 ) 	// >filename
	{
	if( ! m_RedirFile.Open(stringFilename, CFile::modeCreate | CFile::modeWrite | CFile::typeText) )
		m_bRedir = FALSE;
	else
		m_bRedir = TRUE;
	}
if( RedirType == 2 )	// >>filename
	{	// >>filename
	if( ! m_RedirFile.Open(stringFilename, CFile::modeWrite | CFile::typeText) )
		m_bRedir = FALSE;
	else
		{
		m_RedirFile.SeekToEnd();
		m_bRedir = TRUE;
		}
	}
if( !m_bRedir )
	{
	AddToListBox("Redirection failed!",ATLB_SETCURSEL);
	}
} /* end of DoRedir */




void CConnectView::DoExecute(CString s)
{
int i;
CString stringFilename;

if( m_bExecute )
	{
	m_ExecuteFile.Close();	// close the already open file
	m_bExecute = FALSE;
	}                

// get filename
i=0;
while( s[i] && s[i]==' ')
	i++;
stringFilename = s.Right(s.GetLength() - i);
if( stringFilename.IsEmpty() )
	{
	AddToListBox("No execute filename");
	return;
	}
	
if( m_ExecuteFile.Open(stringFilename, CFile::modeRead | CFile::typeText) )
	{
	m_bExecute = TRUE;
	}
else
	{
	AddToListBox("Execute file could not be opened.");
	return;
	}

// begin sending commands 
if( m_ExecuteFile.ReadString(m_SendBuf, 256)	!= NULL )
	{
   	m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
	PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
	}
else
   	{                  
   	m_ExecuteFile.Close();
   	m_bExecute = FALSE;
	}

}




  
    
    
LONG CConnectView::OnAsyncSelect(WPARAM wParam, LPARAM lParam)
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
CConnectDoc* pDoc = GetDocument();
char lpszMessage[100];
char *ptr;
int nBytes, nBytesSent, nError;
int nLen;
UINT numlines;
int nPartial;
CString stringLine;

if( WSAGETSELECTERROR(lParam) != 0 )
	{
	wsprintf(lpszMessage, "Async Select failed (Winsock error %d)", WSAGETSELECTERROR(lParam));
	AddToListBox(lpszMessage,ATLB_SETCURSEL);
	ErrorBox(lpszMessage,WSAGETSELECTERROR(lParam));
	return 0L;
	}
	

switch( WSAGETSELECTEVENT(lParam))
	{
	case FD_CONNECT:
		m_nConnState = CONN_STATE_CONNECTED;
		AddToListBox("Connected!",ATLB_SETCURSEL);
		SetDlgItemText(IDC_CONNVIEW_STATUS,"Logging in to Server...");
		SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON,"Stop Login");
			// Set focus to the Command: edit box
		((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));
		if( WSAAsyncSelect(m_s, m_hWnd, WM_USER_ASYNC_SELECT, FD_READ | FD_WRITE | FD_CLOSE) == SOCKET_ERROR)
			AddToListBox("FD_CONNECT async select failed",ATLB_SETCURSEL);
		m_nExpectSpecific = READ_STATE_FIRSTSERVERINIT;
		break;                                                   

	case FD_READ:
		nBytes = recv(m_s, m_RecvBuf, 1024, MSG_PEEK);
		if( nBytes == SOCKET_ERROR )
			{
			nError = WSAGetLastError();
			if( nError != WSAEWOULDBLOCK )
				{         
				wsprintf(lpszMessage,"FD_READ recv() (Winsock error %d)",nError);
				AddToListBox(lpszMessage,ATLB_SETCURSEL);
				ErrorBox(lpszMessage, nError);
				return 0L;
				}
			return 0L;	
			}
		if( nBytes <=0 )
			return 0L;              
		
		m_RecvBuf[nBytes] = '\0';		// verify a terminator on end
		ptr = _fstrchr(m_RecvBuf,'\n');	// is there a NL somewhere
		if( ptr == NULL )
			{					// no NL found, so
			nPartial = TRUE;    // this is a partial line.
			}
		else
			{
			ptr++;				// skip past the NL
			*ptr = '\0';        // put terminator just past NL
			nPartial = FALSE;   // this is not a partial line
			}
			
		nLen = strlen(m_RecvBuf);	// how long is this (w or w/o NL)	
		nBytes = recv(m_s, m_RecvBuf, nLen, 0);	// get exactly nLen bytes
		
		if( nBytes != nLen )
			MessageBox("nBytes != nLen","Hmmm");
			
		if( nPartial )
			{
			m_RecvBuf[nLen] = '\0';		// terminate the partial string
			m_stringPartial = m_RecvBuf;// store in a string holder
			m_nHavePartial = TRUE;      // flag as being held-over
			return 0L;                  // STOP AT THIS POINT
			}
		else
			{
			m_RecvBuf[nLen-1] = '\0';	// chop NL and terminate
			if( m_nHavePartial )        // if we have a hold-over...
				{                       // concat hold + new
				stringLine = m_stringPartial + m_RecvBuf;
				m_stringPartial = "";   // get rid of hold-over
				m_nHavePartial = FALSE; // turn off flag 
				}
			else
				stringLine = m_RecvBuf; // get a normal NL line
			}

// If we get this far, stringLine has a normal/full line that was
// NL terminated (but not now). We can do servercmd processing now.
			
		numlines = plb->GetCount();		// how many line are in LB
		        						// while more than max we want
		while( numlines-- > pDoc->mdoc_nScrollBufferLines )
			plb->DeleteString(0);       // delete oldest lines...

		ServerCmd(stringLine);
		
				// Post this message to make sure we can read all we can
		PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_READ,0));
		break;
                                             
	case FD_WRITE:
		if( m_nBytesToSend != 0 )
			{                               
			nBytesSent = send(m_s, &m_SendBuf[m_nTotalBytesToSend - m_nBytesToSend], m_nBytesToSend, 0);
			if( nBytesSent == SOCKET_ERROR )
				{                          
				nError = WSAGetLastError();
				if( nError != WSAEWOULDBLOCK )
					{
					wsprintf(lpszMessage,"Error %d sending data",nError);
					AddToListBox(lpszMessage,ATLB_SETCURSEL);
					m_nBytesToSend = m_nTotalBytesToSend = 0;
					ErrorBox(lpszMessage, nError);
					}
				} /* end of SOCKET ERROR */
			else
				{
				m_nBytesToSend = m_nBytesToSend - nBytesSent;
				if( m_nBytesToSend == 0 )
					m_nTotalBytesToSend = 0;
				else
					PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
				}
			} /* end of nBytesToSend != 0 */

		if( m_bExecute && !m_nBytesToSend )
			{
			if( m_ExecuteFile.ReadString(m_SendBuf, 256) != NULL )
				{
		 	  	m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
				PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
			    }
			else
			   	{
			   	lstrcat(m_SendBuf, "\nctld\n");
			  	m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
				PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));				   	                  
 			  	m_ExecuteFile.Close();
 			  	m_bExecute = FALSE;
				}
			}
		break;
    case FD_CLOSE:
		AddToListBox("Connection closed by Empire Host",ATLB_SETCURSEL);
		m_bLoggedOn = FALSE;
		pDoc->mdoc_bOnline = FALSE;		
		if( pDoc->mdoc_bBeep )
			sndPlaySound(pDoc->mdoc_stringWavLogoff, SND_ASYNC);
			//MessageBeep(MB_ICONEXCLAMATION);
		// state, status, site, button,focus
		m_nConnState = CONN_STATE_DISCONNECTED;
		SetDlgItemText(IDC_CONNVIEW_STATUS,"Disconnected");
		// SetDlgItemText(IDC_CONNVIEW_SITE,"");
		SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON,"Reconnect");
		// Set focus to the Connect button
		((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CONNECTBUTTON));
    	break;
	default:
		break;
	} /* end of switch */

return 0L;
} /* end of OnAsyncSelect */






void CConnectView::OnConnviewSendbutton()
{
char lpszCommand[50];
char lpszToLB[50];                                 
int len;
	
	len = GetDlgItemText(IDC_CONNVIEW_CMD, lpszCommand, 50);	// get a copy of the cmd
	lstrcpy(m_SendBuf, lpszCommand);	// store in SendBuf
    m_stringPrevCmd = lpszCommand;
    m_nLastHistory++;
    if( m_nLastHistory >= EMP_HISTORY_STRINGS )
    	m_nLastHistory = 0;
    m_stringHistory[m_nLastHistory] = m_stringPrevCmd;
    
	lstrcpy(lpszToLB,"> ");				// "prompt" for cmd text in ListBox
	lstrcat(lpszToLB, lpszCommand);		// actual command follows my "prompt"
	AddToListBox(lpszToLB,ATLB_SETCURSEL);	// store in ListBox
	if( m_bAuxFile )	
		AddToAuxFile(lpszToLB);
	
	lpszCommand[0] = '\0';                                      // zero cmd string for use
	SetDlgItemText(IDC_CONNVIEW_CMD, lpszCommand);              // in resetting cmd edit control
	// Set focus to the Command: edit box
	((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));

	lstrcat(m_SendBuf, "\n");                                   // add a newline to be sent to emp server
	m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
	PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));
}







void CConnectView::OnConnviewConnectbutton()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
char lpszMessage[100];
char str[80];
CString s;
CConnectDoc* pDoc = GetDocument();
Cmap *m;
int x, y, z, i;

if( m_nConnState == CONN_STATE_DISCONNECTED )
	{
	// ask for empire host, port, user, coun, pass info
	CHostDlg dlg;
	
	dlg.m_stringHost = pDoc->mdoc_stringHost;		// set defaults
	dlg.m_stringPort = pDoc->mdoc_stringPort;     // to current
	dlg.m_stringUser = pDoc->mdoc_stringUser;     // document
	dlg.m_stringCoun = pDoc->mdoc_stringCoun;	    // values.
	dlg.m_stringPass = pDoc->mdoc_stringPass;	
	dlg.m_bKillProc = m_bKillProc;
	if( pDoc->mdoc_MAXX == 0 )
		wsprintf(str,"64");
	else
		wsprintf(str,"%d",pDoc->mdoc_MAXX);
	dlg.m_stringMAXX = str;
	if( pDoc->mdoc_MAXY == 0 )
		wsprintf(str,"64");
	else
		wsprintf(str,"%d",pDoc->mdoc_MAXY);
	dlg.m_stringMAXY = str;
		
	if( dlg.DoModal() == IDCANCEL )		// user pressed the cancel button to abort this connect
		return;
                                        // if get here, user press IDOK, which did DDX to load
                                        // up member strings.
	pDoc->mdoc_stringHost = dlg.m_stringHost;
	pDoc->mdoc_stringPort = dlg.m_stringPort;
	pDoc->mdoc_stringUser = dlg.m_stringUser;
	pDoc->mdoc_stringCoun = dlg.m_stringCoun;	
	pDoc->mdoc_stringPass = dlg.m_stringPass;	
	m_bKillProc = dlg.m_bKillProc;
	pDoc->mdoc_MAXX = atoi(dlg.m_stringMAXX);
	pDoc->mdoc_MAXY = atoi(dlg.m_stringMAXY);
	// set mdoc_ADJX, Y
	pDoc->mdoc_ADJX = pDoc->mdoc_MAXX / 2;
	pDoc->mdoc_ADJY = pDoc->mdoc_MAXY / 2;	
	// allocat map vars
	// and init too...
	for(x=0;x<pDoc->mdoc_MAXX;x++)
		for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		z = x + y;
		i = ((y*pDoc->mdoc_MAXX)+x);
		if( z % 2 )
			{
			pDoc->db[i] = (Cmap *)(-1);
			continue;
			}
		pDoc->db[i] = new Cmap; // tested below for new fail
		if( pDoc->db[i] == (Cmap *)0 )
			{
			AfxMessageBox("new failed in constructor");
			}
		else
			{
			m = pDoc->db[i];
			m->ZeroInit(pDoc, x, y);
			}
		} // end of for loop
		
	SetDlgItemText(IDC_CONNVIEW_SITE,pDoc->mdoc_stringHost);
	wsprintf(lpszMessage,"Looking up host %s",pDoc->mdoc_stringHost);
	AddToListBox(lpszMessage,ATLB_SETCURSEL);

	m_ulIPAddress = inet_addr(pDoc->mdoc_stringHost);	// try for IP number conversion
	if( m_ulIPAddress == INADDR_NONE )
		m_hAsyncHost = WSAAsyncGetHostByName(m_hWnd, WM_USER_ASYNC_HOST_LOOKUP, pDoc->mdoc_stringHost, m_achHostEnt, MAXGETHOSTSTRUCT);
	else
		m_hAsyncHost = WSAAsyncGetHostByAddr(m_hWnd, WM_USER_ASYNC_HOST_LOOKUP, (char *)&m_ulIPAddress, 4, PF_INET, m_achHostEnt, MAXGETHOSTSTRUCT);

	if( m_hAsyncHost == 0 )
		{      
		wsprintf(lpszMessage, "AsyncGetHostByName failed (Winsock error %d)", WSAGetLastError());
		AddToListBox(lpszMessage,ATLB_SETCURSEL);
		FailConnect(7);
		ErrorBox(lpszMessage, WSAGetLastError());
		return;
		}
	else
		{
		m_nConnState = CONN_STATE_ASYNCHOSTLOOKUP;
		SetDlgItemText(IDC_CONNVIEW_STATUS,"Looking up Empire Host...");
		SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON, "Stop...");
		}
	if( m_s != INVALID_SOCKET )
		{
		closesocket(m_s);
		m_s = INVALID_SOCKET;
		}
    if( m_s == INVALID_SOCKET )
    	{
		m_s = socket(AF_INET, SOCK_STREAM, 0);
		if( m_s == INVALID_SOCKET )
			{                                                               
			FailConnect(8);
			AddToListBox("Error: Could not create m_s socket",ATLB_SETCURSEL);
			}
        }
	return;	
	} /* end of CONN_STATE_DISCONNECTED */

if( m_nConnState == CONN_STATE_ASYNCHOSTLOOKUP )
	{
	if( m_hAsyncHost == 0 )
		{
		AddToListBox("Too Late to Cancel Host Lookup",ATLB_SETCURSEL);
		return;
		}
	if( WSACancelAsyncRequest(m_hAsyncHost) != 0 )
		{
		wsprintf(lpszMessage,"Cancel Async Host Lookup Failed (Winsock error %d)",WSAGetLastError());
		ErrorBox(lpszMessage, WSAGetLastError());
		FailConnect(9);
		}
	else
		{
		lstrcpy(lpszMessage,"Async Host Lookup was Cancelled");
		m_nConnState = CONN_STATE_DISCONNECTED;
		SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON, "Connect");
		}
	AddToListBox(lpszMessage,ATLB_SETCURSEL);
	m_hAsyncHost = 0;	// if cancel succeeded or failed, set this back to zero
	FailConnect(10);
	} /* end of CONN_STATE_ASYNCHOSTLOOKUP */

if(m_nConnState == CONN_STATE_HAVEHOST )
	{
	// try to connect
	m_addr.sin_family = AF_INET;
	m_addr.sin_port = htons(atoi(pDoc->mdoc_stringPort));
	m_addr.sin_addr.s_addr = inet_addr(inet_ntoa(m_in));
	
	if( WSAAsyncSelect(m_s, m_hWnd, WM_USER_ASYNC_SELECT, FD_CONNECT) == SOCKET_ERROR)
    	{         
		AddToListBox("Error trying to do Async Select for FD_CONNECT",ATLB_SETCURSEL);
		FailConnect(11);
		return;
		}                                                 

	if( connect(m_s, (LPSOCKADDR)&m_addr, sizeof(m_addr)) == SOCKET_ERROR)
		{
		int nError = WSAGetLastError();
		if( nError != WSAEWOULDBLOCK )
			{
			wsprintf(lpszMessage, "ERROR: connect() failed (Winsock error %d)",nError);                             
			AddToListBox(lpszMessage,ATLB_SETCURSEL);
			ErrorBox(lpszMessage, nError);
			FailConnect(12);
			return;
			}
		m_nConnState = CONN_STATE_ASYNCCONNECT;
		SetDlgItemText(IDC_CONNVIEW_STATUS,"Connecting...");
		SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON, "Wait"); // never seem to get here	
		}
	} /* end of CONNSTATE_HAVEHOST */
		
if( m_nConnState == CONN_STATE_ASYNCCONNECT )
	{ // try to abort connect; Does this make sense?
	// I dont know why this function gets called at this point
	//FailConnect(13);
	SetDlgItemText(IDC_CONNVIEW_STATUS,"Connecting...");
	SetDlgItemText(IDC_CONNVIEW_CONNECTBUTTON, "Stop...");
	} /* end of CONN_STATE_ASYNCCONNECT */ 
	
if( m_nConnState == CONN_STATE_CONNECTED )
	{
	// try to disconnect & clean up, reset things.
	// most resetting is done when the FD_CLOSE is rcvd in asyncselect
	if( m_bLoggedOn )		// if in game, log out
		{
		s = "> quit";
		AddToListBox(s,ATLB_SETCURSEL);	// store in ListBox
		if( m_bAuxFile )
			AddToAuxFile(s);	// aux if in use
		m_bLoggedOn = FALSE;
		pDoc->mdoc_bOnline = FALSE;		
		lstrcpy(m_SendBuf, "quit\n");	// add a newline to be sent to emp server
		m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
		PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));		
		}
 	} /* end of CONN_STATE_CONNECTED */
		
} /* end of OnConnviewConnectbutton */


 
 
 
void CConnectView::OnConnviewCapturebutton()
{
CConnectDoc* pDoc = GetDocument();

if( m_bAuxFile )	// if capturing now, stop capturing
	{
	m_cstdiofileAuxFile.Close();
	SetDlgItemText(IDC_CONNVIEW_CAPTUREBUTTON, "Capture");
	m_bAuxFile = FALSE;
	}
else
	{ // start capturing
	if( ! m_cstdiofileAuxFile.Open(pDoc->mdoc_stringAuxFilename, CFile::modeWrite | CFile::typeText) )
		{
		m_bAuxFile = FALSE;
		ErrorBox("Unable to open Capture File!");
		}
    else
    	{
    	m_bAuxFile = TRUE;
		SetDlgItemText(IDC_CONNVIEW_CAPTUREBUTTON, "Stop >>");
		m_cstdiofileAuxFile.SeekToEnd();
		}
	}
// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));	
}



void CConnectView::OnClearLB()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);

plb->ResetContent();
// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));	
}


	

void CConnectView::OnExecuteFile()
{
CConnectDoc* pDoc = GetDocument();
CFileExecuteDlg dlg;
CString s;

if( m_bLoggedOn )		// if in game, log out
	{	
	//dlg.m_stringExecFilename = pDoc->mdoc_stringExecFilename;	// set defaults
	if( dlg.DoModal() == IDCANCEL )		// user pressed the cancel button to abort this connect
		return;
	// if get here, user press IDOK
    pDoc->mdoc_stringExecFilename = dlg.GetPathName();
	s = "> execute " + pDoc->mdoc_stringExecFilename;
	AddToListBox(s,ATLB_SETCURSEL);	// store in ListBox
	if( m_bAuxFile )
		AddToAuxFile(s);	// aux if in use
	s = "execute " + pDoc->mdoc_stringExecFilename + "\n";
	lstrcpy(m_SendBuf, s);	// add a newline to be sent to emp server
	m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
	PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));		
	}
} // end of OnExecuteFile






void CConnectView::OnRepeatPrevEmpCmd()
{
char lpszCommand[50];
char lpszToLB[50];                                 

	lstrcpy(lpszCommand, m_stringPrevCmd);	
	lstrcpy(m_SendBuf, lpszCommand);	// store in SendBuf
    
	lstrcpy(lpszToLB,"> ");				// "prompt" for cmd text in ListBox
	lstrcat(lpszToLB, lpszCommand);		// actual command follows my "prompt"
	AddToListBox(lpszToLB,ATLB_SETCURSEL);	// store in ListBox
	if( m_bAuxFile )	
		AddToAuxFile(lpszToLB);
	
	lpszCommand[0] = '\0';                                      // zero cmd string for use
	SetDlgItemText(IDC_CONNVIEW_CMD, lpszCommand);              // in resetting cmd edit control

	lstrcat(m_SendBuf, "\n");                                   // add a newline to be sent to emp server
	m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
	PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));

}




void CConnectView::OnEditCopy()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
HGLOBAL hGlobalMemoryBlock;
DWORD dwSize;
char *p;
int nSelList[500];
int *nPtr;
int i, nSelected;
char s[1024];

dwSize = 0;          
nPtr = &(nSelList[0]);          
nSelected = plb->GetSelItems( 500, nPtr );
if( nSelected < 1 )
	return; 
	
for( i=0; i<nSelected; i++)		// What are we looking at copying
	dwSize += (plb->GetTextLen(nSelList[i]) + 2);	// 2 for CR/LF

if( ! OpenClipboard() )
	{
	ErrorBox("OpenClipboard: Clipboard is busy right now...");
	return;     
	}

hGlobalMemoryBlock = GlobalAlloc(GHND, dwSize+4);
if( hGlobalMemoryBlock == NULL )
	{
	::CloseClipboard();
	ErrorBox("Not Enough Memory to Copy to Clipboard");
	return;
	}

p = (char *)GlobalLock( hGlobalMemoryBlock );
for( i=0; i<nSelected; i++)
	{
	plb->GetText(nSelList[i], s);
	strcat(s, "\r\n");
	strcat(p, s);
	plb->SetSel(nSelList[i],FALSE);
	}
GlobalUnlock( hGlobalMemoryBlock );            

::EmptyClipboard();
SetClipboardData(CF_TEXT, hGlobalMemoryBlock);
::CloseClipboard();
 
plb->SetSel(plb->GetCount() - 1, TRUE);
// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));
}



void CConnectView::OnEditCut()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
HGLOBAL hGlobalMemoryBlock;
DWORD dwSize;
char *p;
int nSelList[500];
int *nPtr;
int i, nSelected;
char s[1024];

dwSize = 0;          
nPtr = &(nSelList[0]);          
nSelected = plb->GetSelItems( 500, nPtr );
if( nSelected < 1 )
	return; 
	
for( i=0; i<nSelected; i++)		// What are we looking at copying
	dwSize += (plb->GetTextLen(nSelList[i]) + 2);	// 2 for CR/LF

if( ! OpenClipboard() )
	{
	ErrorBox("OpenClipboard: Clipboard is busy right now...");
	return;     
	}

hGlobalMemoryBlock = GlobalAlloc(GHND, dwSize+4);
if( hGlobalMemoryBlock == NULL )
	{
	::CloseClipboard();
	ErrorBox("Not Enough Memory to Copy to Clipboard");
	return;
	}

p = (char *)GlobalLock( hGlobalMemoryBlock );
for( i=0; i<nSelected; i++)
	{
	plb->GetText(nSelList[i], s);
	strcat(s, "\r\n");
	strcat(p, s);
	}
GlobalUnlock( hGlobalMemoryBlock );            

::EmptyClipboard();
SetClipboardData(CF_TEXT, hGlobalMemoryBlock);
::CloseClipboard(); 

// do same as Copy, but remove the selected lines if successful
for( i=(nSelected-1); i>=0; i--)
	plb->DeleteString(nSelList[i]);
if( plb->GetCount() > 0 )
	plb->SetSel(plb->GetCount() - 1, TRUE);
// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));	
}


void CConnectView::OnLBWider()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
CRect rlb, rp;
GetWindowRect( &rp );
plb->GetWindowRect( &rlb );
plb->MoveWindow((rlb.left - rp.left - 1), (rlb.top - rp.top - 1), rlb.Width() + 20, rlb.Height(), TRUE);
AfxGetApp()->WriteProfileInt("ListBox", "Width", rlb.Width() + 20); 
}
  
  
void CConnectView::OnLBNarrower()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
CRect rlb, rp;
GetWindowRect( &rp );
plb->GetWindowRect( &rlb );
plb->MoveWindow((rlb.left - rp.left - 1), (rlb.top - rp.top - 1), rlb.Width() - 20, rlb.Height(), TRUE);
AfxGetApp()->WriteProfileInt("ListBox", "Width", rlb.Width() - 20); 
}


void CConnectView::OnLBTaller()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
CRect rlb, rp;
GetWindowRect( &rp );
plb->GetWindowRect( &rlb );
plb->MoveWindow((rlb.left - rp.left - 1), (rlb.top - rp.top - 1), rlb.Width(), rlb.Height() + 20, TRUE);
AfxGetApp()->WriteProfileInt("ListBox", "Height", rlb.Height() + 20); 
}


void CConnectView::OnLBShorter()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
CRect rlb, rp;
GetWindowRect( &rp );
plb->GetWindowRect( &rlb );
plb->MoveWindow((rlb.left - rp.left - 1), (rlb.top - rp.top - 1), rlb.Width(), rlb.Height() - 20, TRUE);
AfxGetApp()->WriteProfileInt("ListBox", "Height", rlb.Height() - 20); 
}



void CConnectView::OnEditDeselectAll()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
plb->SelItemRange( FALSE, 0, plb->GetCount() - 1);
if( plb->GetCount() > 0 )
	plb->SetSel(plb->GetCount() - 1, TRUE);

// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));	
}



void CConnectView::OnEditSelectAll()
{
CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
plb->SelItemRange( TRUE, 0, plb->GetCount() - 1);

// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));	
}




 
void CConnectView::OnHistory()
{
CHistoryDlg dlg;

dlg.m_stringCmd = "";	// set defaults       
int iy = m_nLastHistory;
for(int ix=0; ix < EMP_HISTORY_STRINGS; ix++)
	{               
	iy++;
	if( iy >= EMP_HISTORY_STRINGS )
		iy = 0;
	dlg.m_stringHistory[ix] = m_stringHistory[iy];
	}
	
if( dlg.DoModal() == IDCANCEL )		// user pressed the cancel button to abort this connect
	return;

SetDlgItemText(IDC_CONNVIEW_CMD,dlg.m_stringCmd);
// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));
}



void CConnectView::OnBeep()
{
CConnectDoc* pDoc = GetDocument();

if( pDoc->mdoc_bBeep )
	pDoc->mdoc_bBeep = FALSE;
else
	pDoc->mdoc_bBeep = TRUE;	
}




void CConnectView::OnUpdateBeep(CCmdUI* pCmdUI)
{                                  
CConnectDoc* pDoc = GetDocument();

pCmdUI->SetCheck(pDoc->mdoc_bBeep);
}


#ifdef JON_SHIT

void CConnectView::OnDebug()
{
CConnectDoc* pDoc = GetDocument();
CEmpShip *pship;
CEmpPlane *pplane;
CEmpLand *pland;
CString s;
char str[120];

POSITION posS = pDoc->mdoc_ShipList.GetHeadPosition();
while( posS != NULL )
	{
	pship = (CEmpShip *)pDoc->mdoc_ShipList.GetNext( posS );
	wsprintf(str,"%4d %-16.16s %4d,%-4d %1c%4d%%%4d%4d%4d%4d%3d%3d%3d%3d%4d%5d%4d %s",
		(int)pship->unNum,
		(const char *)pship->sType,
		(int)pship->coUserX,
		(int)pship->coUserY,
		pship->ucMembership,
		(int)pship->ucEff,
		(int)pship->unCiv,
		(int)pship->unMil,
		(int)pship->unUW,
		(int)pship->unFood,
		(int)pship->ucPlanes,
		(int)pship->ucHelis,
		(int)pship->ucXlights,
		(int)pship->ucLands,
		(int)pship->ucMob,
		(int)pship->unFuel,
		(int)pship->unTech,
		(const char *)pship->sShipname);
	s = str;
	AddToListBox(s,ATLB_SETCURSEL);
	}                                       

POSITION posL = pDoc->mdoc_LandList.GetHeadPosition();	
while( posL != NULL )
	{
	pland = (CEmpLand *)pDoc->mdoc_LandList.GetNext( posL );
	wsprintf(str,"%4d %-16.16s   %4d,%-4d %1c%4d%%%5d%4d%5d%5d%5d %3d%%%4d%3d%5d",
		(int)pland->unNum,
		(const char *)pland->sType,
		(int)pland->coUserX,
		(int)pland->coUserY,
		pland->ucMembership,
		(int)pland->ucEff,
		(int)pland->ucFort,
		(int)pland->ucMob,
        (int)pland->unFood,
		(int)pland->unFuel,
		(int)pland->unTech,
		(int)pland->ucRetreat,
		(int)pland->ucRadius,
		(int)pland->ucXlights,
		(int)pland->unCarryShip);
	s = str;
	AddToListBox(s,ATLB_SETCURSEL);
	}

POSITION posP = pDoc->mdoc_PlaneList.GetHeadPosition();	
while( posP != NULL )
	{
	pplane = (CEmpPlane *)pDoc->mdoc_PlaneList.GetNext( posP );
	wsprintf(str,"%4d %-19.19s %4d,%-4d %c %3d%% %3d %3d %3d  %3d %3d  %3d%5d%c %c %c %d %s",
		(int)pplane->unNum,
		(const char *)pplane->sType,
		(int)pplane->coUserX,
		(int)pplane->coUserY,
		pplane->ucMembership,
		(int)pplane->ucEff,
		(int)pplane->ucMob,
        (int)pplane->ucAtt,
		(int)pplane->ucDef,
		(int)pplane->unTech,
		(int)pplane->ucRange,
		(int)pplane->ucHard,
		(int)pplane->unCarryUnit,
		pplane->ucCarryType,
		pplane->ucLaunched,
		pplane->ucSync,
		(int)pplane->ucNukeAmt,
		pplane->sNukeType);
	s = str;
	AddToListBox(s,ATLB_SETCURSEL);
	}

} // end of OnDebug




void CConnectView::OnMacro1()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro1.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro1);
SendMacro(lpszCommand);
} // CConnectView::OnMacro1


void CConnectView::OnMacro2()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro2.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro2);
SendMacro(lpszCommand);
} // CConnectView::OnMacro2


void CConnectView::OnMacro3()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro3.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro3);
SendMacro(lpszCommand);
} // CConnectView::OnMacro3


void CConnectView::OnMacro4()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro4.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro4);
SendMacro(lpszCommand);
} // CConnectView::OnMacro4


void CConnectView::OnMacro5()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro5.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro5);
SendMacro(lpszCommand);
} // CConnectView::OnMacro5


void CConnectView::OnMacro6()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro6.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro6);
SendMacro(lpszCommand);
} // CConnectView::OnMacro6


void CConnectView::OnMacro7()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro7.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro7);
SendMacro(lpszCommand);
} // CConnectView::OnMacro7


void CConnectView::OnMacro8()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro8.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro8);
SendMacro(lpszCommand);
} // CConnectView::OnMacro8


void CConnectView::OnMacro9()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro9.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro9);
SendMacro(lpszCommand);
} // CConnectView::OnMacro9


void CConnectView::OnMacro10()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro10.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro10);
SendMacro(lpszCommand);
} // CConnectView::OnMacro10




void CConnectView::SendMacro(char *lpszCommand)
{
char lpszToLB[128];                                        
lstrcpy(m_SendBuf, lpszCommand);	// store in SendBuf
m_stringPrevCmd = lpszCommand;
m_nLastHistory++;
if( m_nLastHistory >= EMP_HISTORY_STRINGS )
	m_nLastHistory = 0;
m_stringHistory[m_nLastHistory] = m_stringPrevCmd;
    
lstrcpy(lpszToLB,"> ");				// "prompt" for cmd text in ListBox
lstrcat(lpszToLB, lpszCommand);		// actual command follows my "prompt"
AddToListBox(lpszToLB,ATLB_SETCURSEL);	// store in ListBox
if( m_bAuxFile )	
	AddToAuxFile(lpszToLB);
	
lpszCommand[0] = '\0';                                      // zero cmd string for use
SetDlgItemText(IDC_CONNVIEW_CMD, lpszCommand);              // in resetting cmd edit control
	// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));

lstrcat(m_SendBuf, "\n");                                   // add a newline to be sent to emp server
m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));	
} // end of CConnectView::SendMacro



void CConnectView::OnPreferences()
{
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);
char str[80];               

// Declare the overall sheet plus its pages
CPropertySheet dlgPropertySheet("WS Empire Preferences");
CServPage servPage;
CGeneralPage genPage;
CSoundPage sounPage;
CMacroPage macrPage;

// Set servPage data
wsprintf(str,"%d",pDoc->mdoc_MAXX);	servPage.m_MAXX = str;
wsprintf(str,"%d",pDoc->mdoc_MAXY);	servPage.m_MAXY = str;
servPage.m_Host = pDoc->mdoc_stringHost;
servPage.m_Port = pDoc->mdoc_stringPort;
servPage.m_User = pDoc->mdoc_stringUser;
servPage.m_Coun = pDoc->mdoc_stringCoun;
servPage.m_Pass = pDoc->mdoc_stringPass;

// Set genPage data
wsprintf(str,"%d",pDoc->mdoc_nLBHeight); genPage.m_Height = str;
wsprintf(str,"%d",pDoc->mdoc_nLBWidth);	genPage.m_Width = str;
wsprintf(str,"%d", -1 * pDoc->mdoc_nLBFontHeight); genPage.m_LBFontSize = str;
wsprintf(str,"%d",(int)pDoc->mdoc_nScrollBufferLines); genPage.m_Maxlines = str;
wsprintf(str,"%d",pDoc->mdoc_nPointSize); genPage.m_PRTFontSize = str;
genPage.m_Capture = pDoc->mdoc_stringAuxFilename;

// Set sounPage data
sounPage.m_UseSounds = pDoc->mdoc_bBeep;
sounPage.m_Default = pDoc->mdoc_stringWavDefault;
sounPage.m_Logon = pDoc->mdoc_stringWavLogon;
sounPage.m_Logoff = pDoc->mdoc_stringWavLogoff;
sounPage.m_OnFlashMsg = pDoc->mdoc_stringWavOnFlashMsg;
sounPage.m_OnInformMsg = pDoc->mdoc_stringWavOnInformMsg;

// Set macrPage data
macrPage.m_F1 = pDoc->mdoc_Macro1;
macrPage.m_F2 = pDoc->mdoc_Macro2;
macrPage.m_F3 = pDoc->mdoc_Macro3;
macrPage.m_F4 = pDoc->mdoc_Macro4;
macrPage.m_F5 = pDoc->mdoc_Macro5;
macrPage.m_F6 = pDoc->mdoc_Macro6;
macrPage.m_F7 = pDoc->mdoc_Macro7;
macrPage.m_F8 = pDoc->mdoc_Macro8;
macrPage.m_F9 = pDoc->mdoc_Macro9;
macrPage.m_F10 = pDoc->mdoc_Macro10;

// Add pages into sheet
dlgPropertySheet.AddPage(&servPage);
dlgPropertySheet.AddPage(&genPage);
dlgPropertySheet.AddPage(&sounPage);
dlgPropertySheet.AddPage(&macrPage);

// Run this as a Modal dialog
if( dlgPropertySheet.DoModal() == IDOK )
	{
	// Get data on servPage:
	if( pDoc->mdoc_stringHost != servPage.m_Host )
		{
		pDoc->mdoc_stringHost = servPage.m_Host;
		pDoc->SetModifiedFlag(TRUE);
		} 
	if( pDoc->mdoc_stringPort != servPage.m_Port )
		{
		pDoc->mdoc_stringPort = servPage.m_Port;
		pDoc->SetModifiedFlag(TRUE);	
		}
	if( pDoc->mdoc_stringUser != servPage.m_User )
		{
		pDoc->mdoc_stringUser = servPage.m_User;
		pDoc->SetModifiedFlag(TRUE);	
		}
	if( pDoc->mdoc_stringCoun != servPage.m_Coun )
		{
		pDoc->mdoc_stringCoun = servPage.m_Coun;
		pDoc->SetModifiedFlag(TRUE);	
		}
	if( pDoc->mdoc_stringPass != servPage.m_Pass )
		{
		pDoc->mdoc_stringPass = servPage.m_Pass;
		pDoc->SetModifiedFlag(TRUE);
		}
	if( pDoc->mdoc_MAXX != atoi(servPage.m_MAXX) )
		{
		pDoc->mdoc_MAXX = atoi(servPage.m_MAXX);
		pDoc->mdoc_ADJX = pDoc->mdoc_MAXX / 2;
		pDoc->SetModifiedFlag(TRUE);
		}
	if( pDoc->mdoc_MAXY != atoi(servPage.m_MAXY) )
		{
		pDoc->mdoc_MAXY = atoi(servPage.m_MAXY);
		pDoc->mdoc_ADJY = pDoc->mdoc_MAXY / 2;
		pDoc->SetModifiedFlag(TRUE);
		}			

	// Get data on genPage
	if( pDoc->mdoc_nLBHeight != atoi(genPage.m_Height) )
		{
		pDoc->mdoc_nLBHeight = atoi(genPage.m_Height);
		AfxGetApp()->WriteProfileInt("ListBox", "Height", pDoc->mdoc_nLBHeight);
		}
	if( pDoc->mdoc_nLBWidth != atoi(genPage.m_Width) )
		{
		pDoc->mdoc_nLBWidth = atoi(genPage.m_Width);
		AfxGetApp()->WriteProfileInt("ListBox", "Width", pDoc->mdoc_nLBWidth);
		}
	if( pDoc->mdoc_nLBFontHeight !=  (-1 * atoi(genPage.m_LBFontSize)) )
		{
		pDoc->mdoc_nLBFontHeight =  -1 * atoi(genPage.m_LBFontSize);
		AfxGetApp()->WriteProfileInt("Listbox", "FontHeight", pDoc->mdoc_nLBFontHeight);
		}
	if( pDoc->mdoc_nScrollBufferLines != (UINT)atoi(genPage.m_Maxlines) )
		{
		pDoc->mdoc_nScrollBufferLines = (UINT)atoi(genPage.m_Maxlines);
		AfxGetApp()->WriteProfileInt("Listbox","ScrollBufferLines",pDoc->mdoc_nScrollBufferLines);
		}
	if( pDoc->mdoc_nPointSize != atoi(genPage.m_PRTFontSize) )
		{
		pDoc->mdoc_nPointSize = atoi(genPage.m_PRTFontSize);
		AfxGetApp()->WriteProfileInt("Printer", "FontSize", pDoc->mdoc_nPointSize);
		}
	if( pDoc->mdoc_stringAuxFilename != genPage.m_Capture )
		{
		pDoc->mdoc_stringAuxFilename = genPage.m_Capture;
		AfxGetApp()->WriteProfileString("Listbox", "AuxFile", pDoc->mdoc_stringAuxFilename);	
		}
	CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
	CRect rlb, rp;
	GetWindowRect( &rp );
	plb->GetWindowRect( &rlb );
	plb->MoveWindow((rlb.left - rp.left - 1), (rlb.top - rp.top - 1), pDoc->mdoc_nLBWidth, pDoc->mdoc_nLBHeight, TRUE);

	// Get data on sounPage
	pDoc->mdoc_bBeep = sounPage.m_UseSounds;
	if( pDoc->mdoc_stringWavDefault != sounPage.m_Default )
		{
		pDoc->mdoc_stringWavDefault = sounPage.m_Default;
		AfxGetApp()->WriteProfileString("Sounds", "Default", sounPage.m_Default);
		}
	if( pDoc->mdoc_stringWavLogon != sounPage.m_Logon )
		{
		pDoc->mdoc_stringWavLogon = sounPage.m_Logon;
		AfxGetApp()->WriteProfileString("Sounds", "Logon", sounPage.m_Logon);
		}
	if( pDoc->mdoc_stringWavLogoff != sounPage.m_Logoff )
		{
		pDoc->mdoc_stringWavLogoff = sounPage.m_Logoff;
		AfxGetApp()->WriteProfileString("Sounds", "Logoff", sounPage.m_Logoff);
		}
	if( pDoc->mdoc_stringWavOnFlashMsg != sounPage.m_OnFlashMsg )
		{
		pDoc->mdoc_stringWavOnFlashMsg = sounPage.m_OnFlashMsg;
		AfxGetApp()->WriteProfileString("Sounds", "OnFlashMsg", sounPage.m_OnFlashMsg);
		}
	if( pDoc->mdoc_stringWavOnInformMsg != sounPage.m_OnInformMsg )
		{
		pDoc->mdoc_stringWavOnInformMsg = sounPage.m_OnInformMsg;
		AfxGetApp()->WriteProfileString("Sounds", "OnInformMsg", sounPage.m_OnInformMsg);
		}
	// Get data on macrPage
	if( pDoc->mdoc_Macro1 != macrPage.m_F1 )
		{
		pDoc->mdoc_Macro1 = macrPage.m_F1;
		AfxGetApp()->WriteProfileString("FKeys", "F1", macrPage.m_F1);
		}
	if( pDoc->mdoc_Macro2 != macrPage.m_F2 )
		{
		pDoc->mdoc_Macro2 = macrPage.m_F2;
		AfxGetApp()->WriteProfileString("FKeys", "F2", macrPage.m_F2);
		}
	if( pDoc->mdoc_Macro3 != macrPage.m_F3 )
		{
		pDoc->mdoc_Macro3 = macrPage.m_F3;
		AfxGetApp()->WriteProfileString("FKeys", "F3", macrPage.m_F3);
		}
	if( pDoc->mdoc_Macro4 != macrPage.m_F4 )
		{
		pDoc->mdoc_Macro4 = macrPage.m_F4;
		AfxGetApp()->WriteProfileString("FKeys", "F4", macrPage.m_F4);
		}
	if( pDoc->mdoc_Macro5 != macrPage.m_F5 )
		{
		pDoc->mdoc_Macro5 = macrPage.m_F5;
		AfxGetApp()->WriteProfileString("FKeys", "F5", macrPage.m_F5);
		}
	if( pDoc->mdoc_Macro6 != macrPage.m_F6 )
		{
		pDoc->mdoc_Macro6 = macrPage.m_F6;
		AfxGetApp()->WriteProfileString("FKeys", "F6", macrPage.m_F6);
		}
	if( pDoc->mdoc_Macro7 != macrPage.m_F7 )
		{
		pDoc->mdoc_Macro7 = macrPage.m_F7;
		AfxGetApp()->WriteProfileString("FKeys", "F7", macrPage.m_F7);
		}
	if( pDoc->mdoc_Macro8 != macrPage.m_F8 )
		{
		pDoc->mdoc_Macro8 = macrPage.m_F8;
		AfxGetApp()->WriteProfileString("FKeys", "F8", macrPage.m_F8);
		}
	if( pDoc->mdoc_Macro9 != macrPage.m_F9 )
		{
		pDoc->mdoc_Macro9 = macrPage.m_F9;
		AfxGetApp()->WriteProfileString("FKeys", "F9", macrPage.m_F9);
		}
	if( pDoc->mdoc_Macro10 != macrPage.m_F10 )
		{
		pDoc->mdoc_Macro10 = macrPage.m_F10;
		AfxGetApp()->WriteProfileString("FKeys", "F10", macrPage.m_F10);
		}
	//pDoc->UpdateAllViews(NULL);
	}
	
} // end of OnPreferences

#endif // JON_SHIT
