// connvw.h : interface of the CConnectView class
//
/////////////////////////////////////////////////////////////////////////////

#define WM_USER_ASYNC_SELECT		(WM_USER + 1)
#define WM_USER_ASYNC_HOST_LOOKUP	(WM_USER + 2)
// other WM_USER msg done elsewhere

#define ATLB_SETCURSEL (1)

#define CONN_STATE_DISCONNECTED		(1)
#define CONN_STATE_ASYNCHOSTLOOKUP	(2)
#define CONN_STATE_HAVEHOST			(3)
#define CONN_STATE_ASYNCCONNECT		(4)
#define CONN_STATE_CONNECTED		(5)

#define READ_STATE_FIRSTSERVERINIT	(1)
#define READ_STATE_USERCMDOK		(2)
#define READ_STATE_COUNCMDOK		(3)
#define READ_STATE_PASSCMDOK		(4)
#define READ_STATE_KILLPROC			(5)
#define READ_STATE_PLAYINIT			(6)

#define EMP_CLIENT_PROTO (2)
#define EMP_HISTORY_STRINGS (20)
// check historyd.h for this...

#define EMP_C_CMDOK		(0)
#define EMP_C_DATA		(1)
#define EMP_C_INIT		(2)
#define EMP_C_EXIT		(3)
#define EMP_C_FLUSH		(4)
#define EMP_C_NOECHO	(5)
#define EMP_C_PROMPT	(6)
#define EMP_C_ABORT		(7)
#define EMP_C_REDIR		(8)
#define EMP_C_PIPE		(9)
#define EMP_C_CMDERR	(0xA)
#define EMP_C_BADCMD	(0xB)
#define EMP_C_EXECUTE	(0xC)
#define EMP_C_FLASH		(0xD)
#define EMP_C_INFORM	(0xE)   

#define MAX_HEADER_LEN 140
#define PARSE_MAP	(1)
#define PARSE_SECT	(2)
#define PARSE_CEN	(3)
#define PARSE_DUMP	(4)
#define PARSE_LAND	(5)
#define PARSE_SHIP	(6)
#define PARSE_PLANE	(7)
#define PARSE_NUKE	(8)

class CConnectView : public CFormView
{
protected: // create from serialization only
	CConnectView();
	DECLARE_DYNCREATE(CConnectView)

public:
//	CConnectDoc *m_pdoc;		// ptr to associated document
	SOCKET m_s;					// socket for this connection
	SOCKADDR_IN m_addr;			// address of socket
	int m_nConnState;           // uses CONN_STATE_ defines 
    int m_nExpectSpecific;      // if >0 then we are expecting specific nCode
    BOOL m_bKillProc;			// need to kill a previous server proc
    BOOL m_bLoggedOn;			// successfully logged on game
    
	int m_nBytesToSend;
	int m_nTotalBytesToSend;
	char m_SendBuf[1028];
	char m_RecvBuf[1028];
	CString m_stringPartial;
	int m_nHavePartial;
	
//	int m_nLBFontHeight;
	CFont m_LBFont;
	
	int m_bAuxFile;
//	CString m_stringAuxFilename;
	CStdioFile m_cstdiofileAuxFile;
	
	int m_bRedir;
	CStdioFile m_RedirFile;
	
	int m_bPipe;
	CStdioFile m_PipeFile;
	int m_nParseType;
	int m_nParseMode;
	int m_nParseLen;
	int m_nXCoord[MAX_HEADER_LEN];
	
	int m_bExecute;
	CStdioFile m_ExecuteFile;
	
//	int m_nPointSize;
								// Variables to support async host lookup
	HANDLE m_hAsyncHost;		// async request handle                  
	char m_achHostEnt[MAXGETHOSTSTRUCT];	// hostent buffer for async call
	PHOSTENT m_pHostEnt;		// pointer to host entry structure
	IN_ADDR m_in;				// Internet address structure
	u_long m_ulIPAddress;		// Internet address
                
	CString m_stringPrevCmd;
	CString m_stringHistory[EMP_HISTORY_STRINGS];
	int m_nLastHistory;
	
	int m_nNewTeles;		// from C_INFORM flag
		
	//{{AFX_DATA(CConnectView)
	enum { IDD = IDD_WSEMPIRE_FORM };
	CString	m_stringCmd;
	//}}AFX_DATA

// Attributes
public:
	CConnectDoc* GetDocument();

// Operations
public:

// Implementation
public:
	virtual ~CConnectView();
	virtual void OnInitialUpdate();
	void FailConnect(int n);
	void ServerCmd(CString &s);
	void ParseMap(CString s);
	void ParseSect(CString s, CString s2);
	void ParseCen(CString s);
	void ParseDump(CString s);
	void ParseShip(CString s);	
	void ParseLand(CString s);	
	void ParsePlane(CString s);	
	void ParseNuke(CString s);	
	void AddToListBox(CString s, BOOL bSetCurSel=0);
	void AddToAuxFile(CString s);
	void AddToRedir(CString s);
	void AddToPipe(CString s, CString s2);
	void DoRedir(CString s);
	void DoExecute(CString s);
	void DoPipe(CString s);
	void SendMacro(char *lpszCommand);
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Printing support
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo);	
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo*);

// Generated message map functions
protected:
	//{{AFX_MSG(CConnectView)
	afx_msg LONG OnAsyncHostLookup(WPARAM wParam, LPARAM lParam);
	afx_msg LONG OnAsyncSelect(WPARAM wParam, LPARAM lParam);
	afx_msg void OnConnviewSendbutton();
	afx_msg void OnConnviewConnectbutton();
	afx_msg void OnConnviewCapturebutton();
	afx_msg void OnClearLB();
	afx_msg void OnExecuteFile();
	afx_msg void OnRepeatPrevEmpCmd();
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();  
	afx_msg void OnLBWider();
	afx_msg void OnLBNarrower();
	afx_msg void OnLBTaller();
	afx_msg void OnLBShorter();
	afx_msg void OnEditDeselectAll();
	afx_msg void OnEditSelectAll();
	afx_msg void OnHistory();
	afx_msg void OnBeep();
	afx_msg void OnUpdateBeep(CCmdUI* pCmdUI);
	afx_msg void OnDebug();
	afx_msg void OnMacro1();
	afx_msg void OnMacro2();
	afx_msg void OnMacro3();
	afx_msg void OnMacro4();
	afx_msg void OnMacro5();
	afx_msg void OnMacro6();
	afx_msg void OnMacro7();
	afx_msg void OnMacro8();
 	afx_msg void OnMacro9();
	afx_msg void OnMacro10(); 		
	afx_msg void OnPreferences();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in connvw.cpp
inline CConnectDoc* CConnectView::GetDocument()
   { return (CConnectDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

