//
// empobj.h - Empire Objects
//

#include "stdafx.h"


class CEmpObject : public CObject
{
public:
	u_short unNum;
	coord coUserX;
	coord coUserY;
	u_char ucEff;
	u_char ucMob;
	u_char ucMembership;	// fleet, wing, army
	u_short unTech;
	CString sType;
};



class CEmpShip : public CEmpObject
{
public:
	u_short unCiv;
	u_short unMil;
	u_short unUW;
	u_short unFood;
	u_char ucPlanes;
	u_char ucHelis;
	u_char ucXlights;
	u_char ucLands;
	u_short unFuel;
	CString sShipname;	
};



class CEmpShipList : public CObList
{
public:
	void AddHeadShip( CEmpShip *ship )
		{ AddHead( ship ); }
	CEmpShip* GetHeadShip()
		{ return (CEmpShip *)GetHead(); }
};



class CEmpPlane : public CEmpObject
{
public:
	u_char ucAtt;
	u_char ucDef;
	u_char ucRange;
	u_char ucHard;
	u_char ucNukeAmt;
	u_char ucCarryType;	// L or S
	u_char ucLaunched;     // Y or N
	u_char ucSync;			// Y or N
	u_short unCarryUnit;
	CString sNukeType;	
};



class CEmpPlaneList : public CObList
{
public:
	void AddHeadPlane( CEmpPlane *plane )
		{ AddHead( plane ); }
	CEmpPlane* GetHeadPlane()
		{ return (CEmpPlane *)GetHead(); }
};




class CEmpLand : public CEmpObject
{
public:
	u_char ucFort;
	u_char ucRetreat;
	u_char ucRadius;
	u_char ucXlights;
    u_short unFood;
	u_short unFuel;
	u_short unCarryShip;
};



class CEmpLandList : public CObList
{
public:
	void AddHeadLand( CEmpLand *land )
		{ AddHead( land ); }
	CEmpLand* GetHeadLand()
		{ return (CEmpLand *)GetHead(); }
};



class CEmpNuke : public CEmpObject
{
public:
	CString sNukeType;
};



class CEmpNukeList : public CObList
{
public:
	void AddHeadNuke( CEmpNuke *nuke )
		{ AddHead( nuke ); }
	CEmpNuke* GetHeadNuke()
		{ return (CEmpNuke *)GetHead(); }
};
