// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "wsempire.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_COMMAND(IDM_NEXT_EMP_WIN, OnNextEmpWin)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_INDEX, CMDIFrameWnd::OnHelpIndex)
	ON_COMMAND(ID_HELP_USING, CMDIFrameWnd::OnHelpUsing)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpIndex)
	ON_COMMAND(IDM_MAP_VIEW, OnMapView)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	IDM_CLEARLB,
		ID_SEPARATOR,
	ID_FILE_PRINT,
	ID_FILE_PRINT_PREVIEW,
		ID_SEPARATOR,
	IDM_REPEAT,
	IDM_EXECUTE,
	IDM_HISTORY,
		ID_SEPARATOR,
	IDM_NEXT_EMP_WIN,
		ID_SEPARATOR,
	ID_APP_ABOUT,
	ID_CONTEXT_HELP,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;      // fail to create
	}
    
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnSize(UINT nType, int cx, int cy)
{
UINT uiX, uiY, uiWidth, uiHeight;
CRect rectWnd;

	CMDIFrameWnd::OnSize(nType, cx, cy);

	AfxGetApp()->m_pMainWnd->GetWindowRect(rectWnd);
	uiX = rectWnd.left;
	uiY = rectWnd.top;
	uiWidth = rectWnd.right - rectWnd.left;
	uiHeight = rectWnd.bottom - rectWnd.top;
	AfxGetApp()->WriteProfileInt("MainWndProperties", "XPos", uiX);
	AfxGetApp()->WriteProfileInt("MainWndProperties", "YPos", uiY);
	AfxGetApp()->WriteProfileInt("MainWndProperties", "Width", uiWidth);
	AfxGetApp()->WriteProfileInt("MainWndProperties", "Height", uiHeight);
	
}
 
 
void CMainFrame::OnMapView()
{
CMDIChildWnd *pActiveChild = MDIGetActive();
CDocument* pDocument;

if (pActiveChild == NULL || (pDocument = pActiveChild->GetActiveDocument()) == NULL)
	{
	TRACE0("Warning: No active document for MapView command\n");
	AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
	return;		// command failed
	}

	// otherwise we have a new frame !
	CDocTemplate* pTemplate = ((CWSempireApp*) AfxGetApp())->pDocTemplateM;
	ASSERT_VALID(pTemplate);
	CFrameWnd* pFrame = pTemplate->CreateNewFrame(pDocument, pActiveChild);
	if (pFrame == NULL)
	{
		TRACE0("Warning: failed to create new frame\n");
		return;		// command failed
	}

	pTemplate->InitialUpdateFrame(pFrame, pDocument);

}


void CMainFrame::OnNextEmpWin()
{

		MDINext();
}
