// map.h
//
/////////////////////////////////////////////////////////////////////////////
#define MAX_CMAP 4096

#define MAP_S1 5
#define MAP_S2 10
#define MAP_S3 15
#define MAP_S4 20

#define MAP_OWNED_UNKNOWN 0
#define MAP_OWNED_YOU 1
#define MAP_OWNED_OTHER 2  

#define SECT_HAS_DESIG (0x1)
#define SECT_HAS_LAND (0x2)
#define SECT_HAS_SHIP (0x4)
#define SECT_HAS_PLANE (0x8)
#define SECT_HAS_NUKE (0x10)
#define SECT_HAS_DIST (0x20)
#define SECT_HAS_MIL (0x40)

typedef unsigned char u_char;
typedef short coord;
typedef unsigned short u_short;

void MarkSectWithDesig(CConnectDoc *pDoc);
void MarkSectWithHighlight(CConnectDoc *pDoc);
void MarkSectWithMil(CConnectDoc *pDoc);
void MarkSectWithDist(CConnectDoc *pDoc);
void MarkSectWithLand(CConnectDoc *pDoc);
void MarkSectWithShip(CConnectDoc *pDoc);
void MarkSectWithPlane(CConnectDoc *pDoc);
void MarkSectWithNuke(CConnectDoc *pDoc);

class Cmap : public CObject
{ 
public:
void ZeroInit(CConnectDoc *pDoc, coord x, coord y);

coord coUserX;			// user's terms: -32:-32,31:31
coord coUserY;                                  
coord coSysX;			// sys terms: 0:0,63:63
coord coSysY;
coord coDistX;			// in terms of user, No dist if cDistX==cUserX and
coord coDistY;			// in terms of user,         if cDistY==cUserY.

u_char ucObjFlags;		// see SECT_HAS_xxx
u_char ucHighlighted;
u_char ucOwned;			// owned by 0=unk, 1=you, 2=other
u_char ucMapChar;		// des

u_char ucNewDes;		// sdes; new designation
u_char ucEff;
u_char ucMob;
u_char ucOccupied;

u_char ucProdOff;
u_char ucMinContent;
u_char ucGoldContent;
u_char ucFert;

u_char ucOilContent;
u_char ucUranContent;
u_char ucWork;
u_char ucTerr;

short	hnAvail;
u_short unCiv;
u_short unMil;
u_short unUW;
u_short unFood;
u_short unShells;
u_short unGuns;
u_short unPetrol;
u_short unIron;
u_short unDust;
u_short unBars;
u_short unOil;
u_short unLcm;
u_short unHcm;
u_short unRads;

u_short unCdist;
u_short unMdist;
u_short unUdist;
u_short unFdist;
u_short unSdist;
u_short unGdist;
u_short unPdist;
u_short unIdist;
u_short unDdist;
u_short unBdist;
u_short unOdist;
u_short unLdist;
u_short unHdist;
u_short unRdist;

CRect rect;		// rectangle in the hex

u_char ucRedraw;
u_char ucOnScreenNow;
};

// no lines below here
