// mapview.cpp : implementation of the CMapView class
//


//Scroll view keystroke handling Chap 4 p69 Inside Vis C++
// MM_ISOTROPIC p88



#include "stdafx.h"
#include "wsempire.h"

#include "conndoc.h"
#include "mapview.h"
#include "sectinfo.h"

#include "sectpge.h"
#include "distpge.h"
#include "commpge.h"
#include "respge.h"
#include "viewpge.h"
#include "shippge.h"
#include "planepge.h"
#include "landpge.h"
#include "nukepge.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


struct SectorDes
	{
	u_char ucMapChar;
	char *Desig;
	};
struct SectorDes sctdes[] = {
	'.',	"sea",
	'^',	"mountain",
	's',	"sanctuary",
	'/',	"wasteland",
	'-',	"wilderness",
	'c',	"capitol",
	'u',	"uranium mine",
	'p',	"park",
	'd',	"defense plant",
	'i',	"shell industry",
	'm',	"iron mine",
	'g',	"gold mine",
	'h',	"harbor",
	'w',	"warehouse",
	'*',	"airfield",
	'a',	"agribusiness",
	'o',	"oil field",
	'j',	"light manufacturing",
	'k',	"heavy manufacturing",
	'f',	"fortress",
	't',	"technical center",
	'r',	"research lab",
	'n',	"nuclear plant",
	'l',	"library/school",
	'+',	"highway",
	')',	"radar installation",
	'!',	"headquarters",
	'#',	"bridge head",
	'=',	"bridge span",
	'b',	"bank",
	'%',	"refinery",
	'e',	"enlistment center",
	0,		""
	};
	
/////////////////////////////////////////////////////////////////////////////
// CMapView

IMPLEMENT_DYNCREATE(CMapView, CScrollView)

BEGIN_MESSAGE_MAP(CMapView, CScrollView)
	//{{AFX_MSG_MAP(CMapView)
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(IDM_CLEARLB, OnClearHighlight)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(IDM_VIEW_DESIGNATION, OnViewDesignation)
	ON_UPDATE_COMMAND_UI(IDM_VIEW_DESIGNATION, OnUpdateViewDesignation)
	ON_COMMAND(IDM_VIEW_DIST, OnViewDist)
	ON_UPDATE_COMMAND_UI(IDM_VIEW_DIST, OnUpdateViewDist)
	ON_COMMAND(IDM_VIEW_HIGHLIGHT, OnViewHighlight)
	ON_UPDATE_COMMAND_UI(IDM_VIEW_HIGHLIGHT, OnUpdateViewHighlight)
	ON_COMMAND(IDM_VIEW_LAND, OnViewLand)
	ON_UPDATE_COMMAND_UI(IDM_VIEW_LAND, OnUpdateViewLand)
	ON_COMMAND(IDM_VIEW_MIL, OnViewMil)
	ON_UPDATE_COMMAND_UI(IDM_VIEW_MIL, OnUpdateViewMil)
	ON_COMMAND(IDM_VIEW_NUKE, OnViewNuke)
	ON_UPDATE_COMMAND_UI(IDM_VIEW_NUKE, OnUpdateViewNuke)
	ON_COMMAND(IDM_VIEW_PLANE, OnViewPlane)
	ON_UPDATE_COMMAND_UI(IDM_VIEW_PLANE, OnUpdateViewPlane)
	ON_COMMAND(IDM_VIEW_SHIP, OnViewShip)
	ON_UPDATE_COMMAND_UI(IDM_VIEW_SHIP, OnUpdateViewShip)
	ON_UPDATE_COMMAND_UI(IDM_EXECUTE, OnUpdateExecute)
	ON_UPDATE_COMMAND_UI(IDM_HISTORY, OnUpdateHistory)
	ON_UPDATE_COMMAND_UI(IDM_REPEAT, OnUpdateRepeat)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_MESSAGE(WM_USER_SECT_INFO, OnSectInfo)
	ON_MESSAGE(WM_USER_SECT_BUTTON, OnSectButton)
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapView construction/destruction

CMapView::CMapView()
{
m_pDlg = new CSectInfo(this);
}



CMapView::~CMapView()
{
delete m_pDlg;
}
 
 
/////////////////////////////////////////////////////////////////////////////
// CMapView drawing

#define EMP_BLACK 0
#define EMP_BLUE 1
#define EMP_GREEN 2
#define EMP_LTGRAY 3
#define EMP_RED 4
#define EMP_BROWN 5
#define EMP_WHITE 6  

static COLORREF colorRGB[] =
	{
	RGB(0,0,0),			// black
	RGB(0,0,255),		// blue
	RGB(0,255,0),		// green
	RGB(192,192,192),   // ltgray
	RGB(255,0,0),       // red
	RGB(128,0,0),       // brown
	RGB(255,255,255)    // white
	};

void CMapView::OnDraw(CDC* pDC)
{
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);
Cmap *sct;
coord x,y;
CBrush *hOldBrush;
CBrush *hBrush;
CBrush hColors[12];
CFont font;
CBrush *hFontBrush;
CPen hWhitePen(PS_SOLID, 2, RGB(255,0,0));	// red
CPen hBlackPen(PS_SOLID, 0, RGB(0,0,0));
CPen *hPen;
int ixColor;

font.CreateFont( (-10), 0, 0, 0, FW_NORMAL, FALSE, FALSE,
		0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_MODERN, "Courier New");
CFont *hOldFont = (CFont *)(pDC->SelectObject(&font));
CPen *hOldPen = (CPen *)(pDC->SelectObject(&hBlackPen));
//pDC->GetTextMetrics(&tm);
	
hColors[EMP_BLACK].CreateSolidBrush(colorRGB[EMP_BLACK]);
hColors[EMP_BLUE].CreateSolidBrush(colorRGB[EMP_BLUE]);
hColors[EMP_GREEN].CreateSolidBrush(colorRGB[EMP_GREEN]);
hColors[EMP_LTGRAY].CreateSolidBrush(colorRGB[EMP_LTGRAY]);
hColors[EMP_RED].CreateSolidBrush(colorRGB[EMP_RED]);
hColors[EMP_BROWN].CreateSolidBrush(colorRGB[EMP_BROWN]);
hColors[EMP_WHITE].CreateSolidBrush(colorRGB[EMP_WHITE]);

pDC->SetPolyFillMode(WINDING);	// hexes should "close-up" and fill
hOldBrush = (CBrush *)pDC->SelectStockObject(LTGRAY_BRUSH);
hFontBrush = &(hColors[EMP_WHITE]);
hPen = &hWhitePen;

pDispShipMemDC = new CDC;
pShipBitmap = new CBitmap;
pShipBitmap->LoadBitmap(IDB_MAPSHIP1);

pDispPlaneMemDC = new CDC;
pPlaneBitmap = new CBitmap;
pPlaneBitmap->LoadBitmap(IDB_MAPPLANE1);

pDispLandMemDC = new CDC;
pLandBitmap = new CBitmap;
pLandBitmap->LoadBitmap(IDB_MAPLAND1);

pDispDistMemDC = new CDC;
pDistBitmap = new CBitmap;
pDistBitmap->LoadBitmap(IDB_MAPDIST1);

pDispMilMemDC = new CDC;
pMilBitmap = new CBitmap;
pMilBitmap->LoadBitmap(IDB_MAPMIL1);

pDispShipMemDC->CreateCompatibleDC(pDC);
pDispShipMemDC->SelectObject(pShipBitmap);

pDispPlaneMemDC->CreateCompatibleDC(pDC);
pDispPlaneMemDC->SelectObject(pPlaneBitmap);

pDispLandMemDC->CreateCompatibleDC(pDC);
pDispLandMemDC->SelectObject(pLandBitmap);

pDispDistMemDC->CreateCompatibleDC(pDC);
pDispDistMemDC->SelectObject(pDistBitmap);

pDispMilMemDC->CreateCompatibleDC(pDC);
pDispMilMemDC->SelectObject(pMilBitmap);
	
for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0; y<pDoc->mdoc_MAXY; y++)
		{
		if( (x+y) % 2 )	// Empire does not use any even/odd pairs
			continue;	// 0,0 2,0 are good; 0,1 1,0 are bad
		sct = pDoc->GetSysSect(x, y);
		if( sct == (Cmap *)NULL )
			{
			// use sctUnknown as arg to DrawHex JON TODO
			continue;
			}
		if(pDoc->mdoc_bSpecialRedraw && (sct->ucRedraw==FALSE) )
			continue;
		switch( sct->ucMapChar )
			{         
			case ' ':
				ixColor = EMP_WHITE; 
			    hBrush = &(hColors[ixColor]);
				break;
			case '^':               
				ixColor = EMP_BROWN; 
			    hBrush = &(hColors[ixColor]);
				break;				
			case '.':
				ixColor = EMP_BLUE; 
				hBrush = &(hColors[ixColor]);
				break;
			case '?':
				ixColor = EMP_RED; 
				hBrush = &(hColors[ixColor]);
				break;				
			default:  
			    if( sct->ucOwned == MAP_OWNED_YOU )
			    	{
			    	ixColor = EMP_GREEN;
			    	hBrush = &(hColors[ixColor]);
			    	}
			    else if( sct->ucOwned == MAP_OWNED_OTHER )
			    	{                         
			    	ixColor = EMP_RED;
			    	hBrush = &(hColors[ixColor]);
			    	}
			    else if( sct->ucMapChar == '-' )
			    	{                         
			    	ixColor = EMP_LTGRAY;
			    	hBrush = &(hColors[ixColor]);
			    	}
			    else
			    	{                         
			    	ixColor = EMP_RED;
			    	hBrush = &(hColors[ixColor]);
			    	}
				break;
			}
		pDC->SelectObject(&hBlackPen);	
        DrawHex(pDC, x, y, sct, hBrush, hFontBrush, ixColor, hPen);
		}

// If used special hint, clear the flag		
if( pDoc->mdoc_bSpecialRedraw )
	pDoc->mdoc_bSpecialRedraw = FALSE;
			
// Restore & cleanup
pDC->SelectObject(hOldBrush);
pDC->SelectObject(hOldPen);
pDC->SelectObject(hOldFont);
delete pDispShipMemDC;
delete pShipBitmap;
delete pDispPlaneMemDC;
delete pPlaneBitmap;
delete pDispLandMemDC;
delete pLandBitmap;
delete pDispDistMemDC;
delete pDistBitmap;
delete pDispMilMemDC;
delete pMilBitmap;

} // end of CMapView::OnDraw






void CMapView::DrawHex(CDC* pDC, coord x, coord y, Cmap *sct, CBrush *hBrush, CBrush *hFontBrush, int ixColor,CPen *hPen)
{
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);
int	sx = x * pDoc->mdoc_nS2 + 20;     // + 20 border
int	sy = y * pDoc->mdoc_nS3 + 20;     // + 20 border
POINT pts[16];
char str[4];
int nStackLevel;	// number of different kinds of units in hex

// reset the bRedraw flag
sct->ucRedraw = FALSE;

/*****************************************/
/*** Create the Hex screen coordinates ***/
/*****************************************/
	pts[0].x = sx;		// north-west
	pts[0].y = sy;
	pts[1].x = sx + pDoc->mdoc_nS2;	// north (top)
	pts[1].y = sy - pDoc->mdoc_nS1;
	pts[2].x = sx + pDoc->mdoc_nS4;	// north-east
	pts[2].y = sy;		
	pts[3].x = sx + pDoc->mdoc_nS4;	// south-east
	pts[3].y = sy + pDoc->mdoc_nS2;		
	pts[4].x = sx + pDoc->mdoc_nS2;	// south (bottom)
	pts[4].y = sy + pDoc->mdoc_nS3;		
	pts[5].x = sx;		// south-west
	pts[5].y = sy + pDoc->mdoc_nS2;		
    pDC->SelectObject(hBrush);
	pDC->Polygon(&(pts[0]),6); 
	sct->rect = CRect(sx, sy, pts[3].x, pts[3].y);

/*****************************************/
/*** Add mapchar Designation or Symbol ***/
/*****************************************/
	                                                    // see if flag to do color is off (ie printout)
	if( pDoc->mdoc_bShowMapChar )                       // see if flag to print MapChar is on
		if( sct->ucMapChar != ' ' && sct->ucMapChar != '.' )	// have struct of "printable"
			{
			pDC->SetTextAlign(TA_CENTER);
			pDC->SetBkColor( colorRGB[ixColor] );
			pDC->SetTextColor( colorRGB[EMP_BLACK] );                             
			str[0] = sct->ucMapChar;
			str[1] = '\0';
			pDC->TextOut(sx + pDoc->mdoc_nS2, sy-2, str, 1);
			sct->ucOnScreenNow |= SECT_HAS_DESIG;
			}

/*****************************/
/*** Show Sector Highlight ***/
/*****************************/
if(sct->ucHighlighted && pDoc->mdoc_bShowHighlight)
	{
	(pts[0].x) += 2;		// north-west
	(pts[0].y) += 2;
	//pts[1].x;	// north (top)
	(pts[1].y) += 2;
	(pts[2].x) -= 2;	// north-east
	(pts[2].y) += 2;		
	(pts[3].x) -= 2;	// south-east
	(pts[3].y) -= 2;		
	//pts[4].x;	// south (bottom)
	(pts[4].y) -= 2;		
	(pts[5].x) += 2;		// south-west
	(pts[5].y) -= 2;
	pts[6].x = pts[0].x;
	pts[6].y = pts[0].y;
	pDC->SelectObject(hPen);
	pDC->Polyline(&(pts[0]),7);
	}

/**************************************************/
/*** Draw in various units, most important last ***/
/**************************************************/
nStackLevel = 0;		
if( (sct->ucObjFlags & SECT_HAS_DIST) && pDoc->mdoc_bShowDist )
	{
	sct->ucOnScreenNow |= SECT_HAS_DIST;
	pDC->BitBlt( sx+2, sy, 16, 10, pDispDistMemDC, 0, 0, SRCCOPY);
	}

if( (sct->ucObjFlags & SECT_HAS_MIL) && pDoc->mdoc_bShowMil )
	{
	sct->ucOnScreenNow |= SECT_HAS_MIL;
	pDC->BitBlt( sx+2, sy, 16, 10, pDispMilMemDC, 0, 0, SRCCOPY);
	}		

if( (sct->ucObjFlags & SECT_HAS_NUKE) && pDoc->mdoc_bShowNukes )
	{
	pDC->SetTextAlign(TA_CENTER);
	pDC->SetBkColor( colorRGB[EMP_WHITE] );
	pDC->SetTextColor( colorRGB[EMP_BLACK] );                             
	str[0] = 'N';
	str[1] = '\0';
	pDC->TextOut(sx + pDoc->mdoc_nS2, sy-2, str, 1);
	sct->ucOnScreenNow |= SECT_HAS_NUKE;
	}
 
if( (sct->ucObjFlags & SECT_HAS_PLANE) && pDoc->mdoc_bShowPlanes )
	{    
	sct->ucOnScreenNow |= SECT_HAS_PLANE;
	pDC->BitBlt( sx+2, sy, 16, 10, pDispPlaneMemDC, 0, 0, SRCCOPY);
	}

if( (sct->ucObjFlags & SECT_HAS_LAND) && pDoc->mdoc_bShowLand )
	{
	sct->ucOnScreenNow |= SECT_HAS_LAND;
	pDC->BitBlt( sx+2, sy, 16, 10, pDispLandMemDC, 0, 0, SRCCOPY);
	}

if( (sct->ucObjFlags & SECT_HAS_SHIP) && pDoc->mdoc_bShowShips )
	{
	//pDC->SetTextAlign(TA_CENTER);
	///pDC->SetBkColor( colorRGB[EMP_WHITE] );
	//pDC->SetTextColor( colorRGB[EMP_BLACK] );                             
	//str[0] = 'S';
	//str[1] = '\0';
	//pDC->TextOut(sx + pDoc->mdoc_nS2, sy-2, str, 1);
	sct->ucOnScreenNow |= SECT_HAS_SHIP;
	pDC->BitBlt( sx+2, sy, 16, 10, pDispShipMemDC, 0, 0, SRCCOPY);
	}
	
} // end of CMapView::DrawHex
		



void CMapView::OnInitialUpdate()
{
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);
int	sx = pDoc->mdoc_MAXX * pDoc->mdoc_nS2 + 40;     // + 20 border
int	sy = pDoc->mdoc_MAXY * pDoc->mdoc_nS3 + 40;     // + 20 border

CScrollView::OnInitialUpdate();
CSize totalSize = CSize( sx, sy );
CSize pageSize = CSize( totalSize.cx / 2, totalSize.cy / 3 );
CSize lineSize = CSize( totalSize.cx / 10, totalSize.cy / 10 );
SetScrollSizes( MM_TEXT, totalSize, pageSize, lineSize );
}




LONG CMapView::OnSectInfo(UINT wParam, LONG lParam)
{
m_pDlg->DestroyWindow();
return 0L;
}




/////////////////////////////////////////////////////////////////////////////
// CMapView printing

BOOL CMapView::OnPreparePrinting(CPrintInfo* pInfo)
{
if( pInfo == NULL )	// Can be null if DC will be for a screen?
	return( 0 );	// cancel the printing
pInfo->m_bContinuePrinting = TRUE;	
return DoPreparePrinting(pInfo); // default preparation
}





#define PIX2TWIP(x) ((x)*15)


// This is specially overridden since we don't know how many pages
// are to be printed during OnPreparePrinting.  This is called for
// each page, and tests to see if we are done.    
void CMapView::OnPrepareDC(CDC *pDC, CPrintInfo* pInfo = NULL)
{
CConnectDoc* pDoc = GetDocument();
CFont font;
RECT rect;
int nHeight, nLinesPerPage, nItems;
TEXTMETRIC tm;
int nPointSize = pDoc->mdoc_nPointSize;

if( pInfo != NULL )
	{
	pDC->SetMapMode(MM_TWIPS);
	rect = pInfo->m_rectDraw;
	pDC->DPtoLP(&rect);
	font.CreateFont( (-20 * nPointSize), 0, 0, 0, FW_BOLD, FALSE, FALSE,
		0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_MODERN, "Courier New");
	CFont *pOldFont = (CFont *)(pDC->SelectObject(&font));
	pDC->GetTextMetrics(&tm);
	nHeight = PIX2TWIP(pDoc->mdoc_S2);
	nLinesPerPage = -(rect.bottom / nHeight);
	nLinesPerPage -= 3;	// for header + space at foot
	nItems = pDoc->mdoc_MAXY;
	if( (nItems+nLinesPerPage) <= ((int)pInfo->m_nCurPage * nLinesPerPage) )
		pInfo->m_bContinuePrinting = FALSE;
	else
		pInfo->m_bContinuePrinting = TRUE;	
	pDC->SelectObject(pOldFont);
	}
	
// has to be after the other code...
CScrollView::OnPrepareDC(pDC, pInfo);

// then rechecked after OnPrepareDC base class
if( pInfo != NULL )
	{
	if( (nItems+nLinesPerPage) <= ((int)pInfo->m_nCurPage * nLinesPerPage) )
		pInfo->m_bContinuePrinting = FALSE;
	else
		pInfo->m_bContinuePrinting = TRUE;
	}
} // end of OnPrepareDC





//
// This function asks us to draw page # m_nCurPage
// Print headers, footers, etc.
// would call OnDraw if was a WYSIWYG application.
// Use m_rectDraw for the printable area. Adjust this if doing header/footer
// Select any GDI objects each time in this function.
// p340 Inside VC++

void CMapView::OnPrint(CDC* pDC, CPrintInfo *pInfo)
{
CConnectDoc* pDoc = GetDocument();
CPoint point;
int nSelected;
int nPage, nStartLine, nEndLine;
int nLinesPerPage, nHeight, nHgt;
CString s;
CFont font;
CFont fontH;              
TEXTMETRIC tm;
int nPointSize = pDoc->mdoc_nPointSize;
RECT rect;
char str[80];

if( pInfo == NULL )
	return;               
	
pDC->SetMapMode(MM_TWIPS);
//wsprintf(str,"%d %d %d %d",pInfo->m_rectDraw.left, pInfo->m_rectDraw.top, pInfo->m_rectDraw.right, pInfo->m_rectDraw.bottom);
rect = pInfo->m_rectDraw;
pDC->DPtoLP(&rect);                          
//wsprintf(str2,"%d %d %d %d",rect.left, rect.top, rect.right, rect.bottom);
                                                    
fontH.CreateFont( (-20 * nPointSize), 0, 0, 0, FW_BOLD, FALSE, FALSE,
	0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
	CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
	DEFAULT_PITCH | FF_MODERN, "Courier New");
CFont *pOldFont = (CFont *)(pDC->SelectObject(&fontH));
pDC->GetTextMetrics(&tm);
nHgt = nHeight = PIX2TWIP(pDoc->mdoc_S2);
CPen hBlackPen(PS_SOLID, 0, RGB(0,0,0));

// Figure lines per page, minus 2 used for header.
nLinesPerPage = -(rect.bottom / nHeight);
nLinesPerPage -= 3;	// for header + space at foot
nPage = pInfo->m_nCurPage;
nStartLine = (nPage - 1) * nLinesPerPage;
nEndLine = nStartLine + nLinesPerPage;

nSelected = pDoc->mdoc_MAXY;
if( nSelected < nEndLine )
	nEndLine = nSelected;
	
// page header 
pDC->Rectangle(rect.left, rect.top, rect.right, (rect.top - ((int)(2.5 * (float)nHgt))));
s = "WS Empire Client v2.0";
pDC->SetTextAlign(TA_CENTER);
pDC->TextOut(rect.right / 2, -(nHgt / 2), s);
wsprintf(str,"%d,%d,%d Page %d",nStartLine,nEndLine,nSelected,nPage);
pDC->SetTextAlign(TA_RIGHT);                             
pDC->TextOut(rect.right - 720, -(nHgt / 2), str, strlen(str));

font.CreateFont( (-20 * nPointSize), 0, 0, 0, 400, FALSE, FALSE,
	0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
	CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
	DEFAULT_PITCH | FF_MODERN, "Courier New");
pDC->SelectObject(&font);

point.x = pInfo->m_rectDraw.left;
point.y = pInfo->m_rectDraw.top - (3 * nHgt);
//point.y = pInfo->m_rectDraw.top - (2 * nHeight); trying to avoid hitting rect box

// page body
pDC->SetPolyFillMode(WINDING);	// hexes should "close-up" and fill
CPen *hOldPen = (CPen *)(pDC->SelectObject(&hBlackPen));
int	x, sx;
int	y, sy;
POINT pts[16];
Cmap *sct;

CBrush *hOldBrush = (CBrush *)pDC->SelectStockObject(WHITE_BRUSH);
		
for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0; y<pDoc->mdoc_MAXY; y++)
		{
		if( (x+y) % 2 )	// Empire does not use any even/odd pairs
			continue;	// 0,0 2,0 are good; 0,1 1,0 are bad
		sct = pDoc->GetSysSect(x, y);
		if( sct == (Cmap *)NULL )
			{
			// use sctUnknown as arg to DrawHex JON TODO
			continue;
			}
		sx = x * pDoc->mdoc_nS2 + 20;     // + 20 border
		sy = - ((y * pDoc->mdoc_nS3) + (3 * pDoc->mdoc_nS2));
	/*****************************************/
	/*** Create the Hex screen coordinates ***/
	/*****************************************/
		if( pDoc->mdoc_bPrintHexGrid )
			{ 
			pts[0].x = PIX2TWIP(sx);		// north-west
			pts[0].y = PIX2TWIP(sy);
			pts[1].x = PIX2TWIP(sx + pDoc->mdoc_nS2);	// north (top)
			pts[1].y = PIX2TWIP(sy + pDoc->mdoc_nS1);
			pts[2].x = PIX2TWIP(sx + pDoc->mdoc_nS4);	// north-east
			pts[2].y = PIX2TWIP(sy);		
			pts[3].x = PIX2TWIP(sx + pDoc->mdoc_nS4);	// south-east
			pts[3].y = PIX2TWIP(sy - pDoc->mdoc_nS2);		
			pts[4].x = PIX2TWIP(sx + pDoc->mdoc_nS2);	// south (bottom)
			pts[4].y = PIX2TWIP(sy - pDoc->mdoc_nS3);		
			pts[5].x = PIX2TWIP(sx);		// south-west
			pts[5].y = PIX2TWIP(sy - pDoc->mdoc_nS2);
			if( sct->ucOwned == MAP_OWNED_YOU )
			    pDC->SelectStockObject(LTGRAY_BRUSH);
			else
				pDC->SelectStockObject(WHITE_BRUSH);
			pDC->SetBkMode(OPAQUE);		
			pDC->Polygon(&(pts[0]),6); 
			}
	/*****************************************/
	/*** Add mapchar Designation or Symbol ***/
	/*****************************************/
		pDC->SetTextAlign(TA_CENTER);
		str[0] = sct->ucMapChar;
		str[1] = '\0';
		pDC->SetBkMode(TRANSPARENT);
		pDC->TextOut(PIX2TWIP(sx + pDoc->mdoc_nS2), PIX2TWIP(sy+2), str, 1);
		
		//compatibDC
		//pDC->StretchBlt( sx+2, sy, 16, 10, pDispLandMemDC, 0, 0, SRCCOPY);
		}		
// page footer

// cleanup
pDC->SelectObject(pOldFont);
pDC->SelectObject(hOldPen);
pDC->SelectObject(hOldBrush);

} // end of OnPrint





void CMapView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMapView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}



/////////////////////////////////////////////////////////////////////////////
// CMapView diagnostics

#ifdef _DEBUG
void CMapView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMapView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CConnectDoc* CMapView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CConnectDoc)));
	return (CConnectDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMapView message handlers

void CMapView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	//
	//	CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
	//
switch( nChar )
	{         
	case VK_HOME:
		OnVScroll(SB_TOP, 0, NULL);
		OnHScroll(SB_LEFT, 0, NULL);
		break;                      
	case VK_END:
		OnVScroll(SB_BOTTOM, 0, NULL);
		OnHScroll(SB_RIGHT, 0, NULL);	
		break;	
	case VK_UP:
		OnVScroll(SB_LINEUP, 0, NULL);	
		break;	
	case VK_DOWN:
		OnVScroll(SB_LINEDOWN, 0, NULL);	
		break;	
	case VK_PRIOR:
		OnVScroll(SB_PAGEUP, 0, NULL);
		break;	
	case VK_NEXT: 
		OnVScroll(SB_PAGEDOWN, 0, NULL);	
		break;	
	case VK_LEFT:  
		OnHScroll(SB_LINELEFT, 0, NULL);	
		break;	
	case VK_RIGHT: 
		OnHScroll(SB_LINERIGHT, 0, NULL);	
		break;
	default:
		break;
	} // end of switch	
} // end of OnKeyDown



void CMapView::OnRButtonDown(UINT nFlags, CPoint point)
{
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);               
Cmap *sct;
int i;
char str[80];                                  
char s[80];
CPoint pt = GetDeviceScrollPosition();

// Adjust the mouse point for how far the screen is scrolled.
	point.x += pt.x;
	point.y += pt.y;
    
// Make sure we have a Sector Info dialog box created.
	if( m_pDlg->GetSafeHwnd() == 0 )
		m_pDlg->Create();
	else
		{
		if( pDoc->mdoc_bRightBClose )
			{
			m_pDlg->DestroyWindow();
			CScrollView::OnRButtonDown(nFlags, point);
			return;
			}
		}
		
// Loop thru map array for Hit-Test
	sct = (Cmap *)0;    
    for(i=0; i<MAX_CMAP; i++)
		if( (pDoc->db[i] != (Cmap *)(-1)) && (pDoc->db[i] != (Cmap *)0) )
			if( pDoc->db[i]->rect.PtInRect(point) )
				{
				sct = pDoc->db[i]; // found the one
                break;
				}

// lookout for a null pointer if not found.				
	if( sct == (Cmap *)0 )
		{
		CScrollView::OnRButtonDown(nFlags, point);
		return; // <-------- RETURN ----------------------------------
		}

/*************************************************/
/*** Real Sector, Give whats known if anything ***/
/*************************************************/
// Designation
	wsprintf(s, "%c  Unknown", sct->ucMapChar);
	char cNewDes = ' ';
	if( sct->ucNewDes != '_' )
		cNewDes = sct->ucNewDes;
	for( int x=0; sctdes[x].ucMapChar; x++)
		if( sctdes[x].ucMapChar == sct->ucMapChar )
			wsprintf(s, "%c%c  %s", sct->ucMapChar, cNewDes, sctdes[x].Desig);		
	m_pDlg->m_des = s;
	
	wsprintf(s, "%d%%", (int)sct->ucEff);
	m_pDlg->m_eff = s;

	wsprintf(s, "%d", (int)sct->ucMob);
	m_pDlg->m_mob = s;	
	
	wsprintf(s, "%hu", sct->unCiv);
	m_pDlg->m_civ = s;

	wsprintf(s, "%hu", sct->unMil);
	m_pDlg->m_mil = s;

	wsprintf(s, "%hu", sct->unUW);
	m_pDlg->m_uw = s;	
	
	wsprintf(s, "%hu", sct->unFood);
	m_pDlg->m_food = s;
	
	wsprintf(s, "%hu", sct->unShells);
	m_pDlg->m_shells = s;
	
	wsprintf(s, "%hu", sct->unGuns);
	m_pDlg->m_guns = s;
		
	wsprintf(s, "%hu", sct->unPetrol);
	m_pDlg->m_petrol = s;
	
	wsprintf(s, "%hu", sct->unIron);
	m_pDlg->m_iron = s;
	
	wsprintf(s, "%hu", sct->unDust);
	m_pDlg->m_dust = s;	
	
	wsprintf(s, "%hu", sct->unBars);
	m_pDlg->m_bars = s;
	
	wsprintf(s, "%hu", sct->unOil);
	m_pDlg->m_oil = s;
	
	wsprintf(s, "%hu", sct->unLcm);
	m_pDlg->m_lcm = s;	
	
	wsprintf(s, "%hu", sct->unHcm);
	m_pDlg->m_hcm = s;	
	
	wsprintf(s, "%hu", sct->unRads);
	m_pDlg->m_rads = s;	
	
// Dist XY
	if( (sct->coDistX == sct->coUserX) && (sct->coDistY == sct->coUserY) )
		wsprintf(s, "none");
	else
		wsprintf(s, "%hd,%hd", sct->coDistX, sct->coDistY);
	m_pDlg->m_dist_xy = s;
			
// Update Status Bar and Dialog Title
	wsprintf(str,"Sector %hd,%hd",sct->coUserX, sct->coUserY);
	CStatusBar* pStatus = (CStatusBar *)AfxGetApp()->m_pMainWnd->GetDescendantWindow(AFX_IDW_STATUS_BAR);
	if( pStatus )
		pStatus->SetPaneText(0,str);
	m_pDlg->SetWindowText(str);
	m_pDlg->UpdateData(FALSE);	// Force data from member vars into box.
	
	CScrollView::OnRButtonDown(nFlags, point);
	
} // end of OnRButtonDown




void CMapView::OnClearHighlight()
{
coord x, y;
Cmap *sct;
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct != (Cmap *)0 )
			if( sct->ucHighlighted )
				{
				sct->ucHighlighted = FALSE;
				sct->ucRedraw = TRUE;
				}
		}
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);	// Rect of inval, BOOL bErase background
} // end of OnClearHighlight



void MarkSectWithHighlight(CConnectDoc *pDoc)
{
Cmap *sct;
coord x,y;

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct == (Cmap *)0 )
			continue;
		if( sct->ucHighlighted )
			sct->ucRedraw = TRUE;
		}
} // end of MarkSectWithHighlight






void MarkSectWithDesig(CConnectDoc *pDoc)
{
Cmap *sct;
coord x,y;

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct == (Cmap *)0 )
			continue;
		sct->ucRedraw = TRUE;
		}
} // end of MarkSectWithDesig





void MarkSectWithDist(CConnectDoc *pDoc)
{
Cmap *sct;
coord x,y;

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct == (Cmap *)0 )
			continue;
		if( (sct->coDistX == sct->coUserX) && (sct->coDistY == sct->coUserY) )
			{ // does NOT have dist
			sct->ucObjFlags &= (~SECT_HAS_DIST);
			if( sct->ucOnScreenNow & SECT_HAS_DIST )
				{
				sct->ucOnScreenNow &= (~SECT_HAS_DIST);
				sct->ucRedraw = TRUE;
				}
			}
		else
			{ // Does have Dist
			sct->ucObjFlags |= SECT_HAS_DIST;
			sct->ucRedraw = TRUE;
			}
		}
} // end of MarkSectWithDist




void MarkSectWithMil(CConnectDoc *pDoc)
{
Cmap *sct;
coord x,y;

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct == (Cmap *)0 )
			continue;
		if( sct->unMil > 0 )
			{
			sct->ucObjFlags |= SECT_HAS_MIL;
			sct->ucRedraw = TRUE;
			}
		else
			{
			sct->ucObjFlags &= (~SECT_HAS_MIL);
			if( sct->ucOnScreenNow & SECT_HAS_MIL )
				{
				sct->ucOnScreenNow &= (~SECT_HAS_MIL);
				sct->ucRedraw = TRUE;			   
				}
			}
		}
} // end of MarkSectWithMil




void MarkSectWithLand(CConnectDoc *pDoc)
{
CEmpLand *pland;
Cmap *sct;
coord x,y;

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct == (Cmap *)0 )
			continue;
		sct->ucObjFlags &= (~SECT_HAS_LAND);
		if( sct->ucOnScreenNow & SECT_HAS_LAND )
			{
			sct->ucOnScreenNow &= (~SECT_HAS_LAND);
			sct->ucRedraw = TRUE;			   
			}		
		}

POSITION pos = pDoc->mdoc_LandList.GetHeadPosition();
while( pos != NULL )
	{
	pland = (CEmpLand *)pDoc->mdoc_LandList.GetNext( pos );
	sct = pDoc->GetUserSect(pland->coUserX, pland->coUserY);
	sct->ucObjFlags |= SECT_HAS_LAND;
	sct->ucRedraw = TRUE;
	}
} // end of MarkSectWithLand





void MarkSectWithShip(CConnectDoc *pDoc)
{
CEmpShip *pship;
Cmap *sct;
coord x, y;

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct == (Cmap *)0 )
			continue;
		sct->ucObjFlags &= (~SECT_HAS_SHIP);
		if( sct->ucOnScreenNow & SECT_HAS_SHIP )
			{
			sct->ucOnScreenNow &= (~SECT_HAS_SHIP);
			sct->ucRedraw = TRUE;			   
			}		
		}

POSITION pos = pDoc->mdoc_ShipList.GetHeadPosition();
while( pos != NULL )
	{
	pship = (CEmpShip *)pDoc->mdoc_ShipList.GetNext( pos );
	sct = pDoc->GetUserSect(pship->coUserX, pship->coUserY);
	sct->ucObjFlags |= SECT_HAS_SHIP;
	sct->ucRedraw = TRUE;
	}
} // end of MarkSectWithShip




void MarkSectWithPlane(CConnectDoc *pDoc)
{
CEmpPlane *pplane;
Cmap *sct;
coord x,y;

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct == (Cmap *)0 )
			continue;
		sct->ucObjFlags &= (~SECT_HAS_PLANE);
		if( sct->ucOnScreenNow & SECT_HAS_PLANE )
			{
			sct->ucOnScreenNow &= (~SECT_HAS_PLANE);
			sct->ucRedraw = TRUE;			   
			}		
		}

POSITION pos = pDoc->mdoc_PlaneList.GetHeadPosition();
while( pos != NULL )
	{
	pplane = (CEmpPlane *)pDoc->mdoc_PlaneList.GetNext( pos );
	sct = pDoc->GetUserSect(pplane->coUserX, pplane->coUserY);
	sct->ucObjFlags |= SECT_HAS_PLANE;
	sct->ucRedraw = TRUE;
	}
} // end of MarkSectWithPlane





void MarkSectWithNuke(CConnectDoc *pDoc)
{
CEmpNuke *pnuke;
Cmap *sct;
coord x,y;

for(x=0;x<pDoc->mdoc_MAXX;x++)
	for(y=0;y<pDoc->mdoc_MAXY;y++)
		{
		if( (x+y) % 2 )
			continue;
		sct = pDoc->GetSysSect(x,y);	
		if( sct == (Cmap *)0 )
			continue;
		sct->ucObjFlags &= (~SECT_HAS_NUKE);
		if( sct->ucOnScreenNow & SECT_HAS_NUKE );
			{
			sct->ucOnScreenNow &= (~SECT_HAS_NUKE);
			sct->ucRedraw = TRUE;			   
			}		
		}

POSITION pos = pDoc->mdoc_NukeList.GetHeadPosition();
while( pos != NULL )
	{
	pnuke = (CEmpNuke *)pDoc->mdoc_NukeList.GetNext( pos );
	sct = pDoc->GetUserSect(pnuke->coUserX, pnuke->coUserY);
	sct->ucObjFlags |= SECT_HAS_NUKE;
	sct->ucRedraw = TRUE;
	}
} // end of MarkSectWithNuke




LONG CMapView::OnSectButton(UINT wParam, LONG lParam)
{
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);

switch( wParam )
	{
	case SECT_BUTTON_MIL:
		MarkSectWithMil(pDoc);
		pDoc->mdoc_bShowMil = TRUE;
		pDoc->mdoc_bSpecialRedraw = TRUE;
		InvalidateRect(NULL, FALSE);	
		break;
	case SECT_BUTTON_DIST:
		MarkSectWithDist(pDoc);
		pDoc->mdoc_bShowDist = TRUE;
		pDoc->mdoc_bSpecialRedraw = TRUE;
		InvalidateRect(NULL, FALSE);		
		break;		
	case SECT_BUTTON_LAND:
		MarkSectWithLand(pDoc);
		pDoc->mdoc_bShowLand = TRUE;
		pDoc->mdoc_bSpecialRedraw = TRUE;				
		InvalidateRect(NULL, FALSE);
		break;	
	case SECT_BUTTON_SHIPS:
		MarkSectWithShip(pDoc);
		pDoc->mdoc_bShowShips = TRUE;
		pDoc->mdoc_bSpecialRedraw = TRUE;				
		InvalidateRect(NULL, FALSE);
		break;	
	case SECT_BUTTON_PLANES:
		MarkSectWithPlane(pDoc);
		pDoc->mdoc_bShowPlanes = TRUE;
		pDoc->mdoc_bSpecialRedraw = TRUE;
		InvalidateRect(NULL, FALSE);	
		break;	
	case SECT_BUTTON_NUKES:
		MarkSectWithNuke(pDoc);	
		pDoc->mdoc_bShowNukes = TRUE;
		pDoc->mdoc_bSpecialRedraw = TRUE;			
		InvalidateRect(NULL, FALSE);	
		break;
	default:
		break;
	}
//m_pDlg->DestroyWindow();
return 0L;
}




void CMapView::OnLButtonDown(UINT nFlags, CPoint point)
{
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);               
Cmap *sct;
int i;
char str[120];                                  
CString s;
CEmpShip *pship;
CEmpPlane *pplane;
CEmpLand *pland;
char cChar;
CPoint pt = GetDeviceScrollPosition();

// Adjust the mouse point for how far the screen is scrolled.
point.x += pt.x;
point.y += pt.y;
    
// Loop thru map array for Hit-Test
sct = (Cmap *)0;    
for(i=0; i<MAX_CMAP; i++)
	if( (pDoc->db[i] != (Cmap *)(-1)) && (pDoc->db[i] != (Cmap *)0) )
		if( pDoc->db[i]->rect.PtInRect(point) )
			{
			sct = pDoc->db[i]; // found the one
            break;
			}

// lookout for a null pointer if not found.				
if( sct == (Cmap *)0 )
    {
	CScrollView::OnLButtonDown(nFlags, point);
	return;
	}

// Create Sheet title
wsprintf(str, "%c  Unknown %hd,%hd", sct->ucMapChar, sct->coUserX, sct->coUserY);
char cNewDes = ' ';
if( sct->ucNewDes != '_' )
	cNewDes = sct->ucNewDes;
for( int x=0; sctdes[x].ucMapChar; x++)
	if( sctdes[x].ucMapChar == sct->ucMapChar )
		wsprintf(str, "%c%c %s at %hd,%hd", sct->ucMapChar, cNewDes, sctdes[x].Desig, sct->coUserX, sct->coUserY);		

// Declare the overall sheet plus its pages
CPropertySheet dlgPropertySheet(str);
CSectorPage sectPage;
CDistPage distPage;
CCommPage commPage;
CResPage resPage;
CViewPage viewPage;
CShipPage shipPage;
CPlanePage planePage;
CLandPage landPage;
CNukePage nukePage;

// Set sectPagepage data
wsprintf(str,"%d",(int)sct->ucTerr);	sectPage.m_terr = str;
wsprintf(str,"%hu",sct->unCiv);	sectPage.m_civs = str;
wsprintf(str,"%hu",sct->unMil);	sectPage.m_mil = str;
wsprintf(str,"%hu",sct->unUW);	sectPage.m_uws = str;
if( (sct->coUserX==sct->coDistX) && (sct->coUserY==sct->coDistY) )
	wsprintf(str,"NONE");
else
	wsprintf(str,"%hd,%hd",sct->coDistX, sct->coDistY); sectPage.m_distxy = str;
wsprintf(str,"%hu",sct->unFood); sectPage.m_food = str;
wsprintf(str,"%c",sct->ucOccupied); sectPage.m_occu = str;
wsprintf(str,"%d%%",(int)sct->ucEff); sectPage.m_eff = str;
wsprintf(str,"%d",(int)sct->ucMob); sectPage.m_mob = str;
wsprintf(str,"%d%%",(int)sct->ucWork); sectPage.m_work = str;	
wsprintf(str,"%hd",sct->hnAvail);	sectPage.m_avail = str;
if( sct->ucProdOff == 'n' )
	sectPage.m_prodstop = "*OFF*";
else
	sectPage.m_prodstop = "On";
if( sct->ucNewDes == '_' )
	str[0] = '\0';
else
	wsprintf(str,"%c",sct->ucNewDes);
sectPage.m_newdes = str;	
	
// Set distPage data
if( (sct->coUserX==sct->coDistX) && (sct->coUserY==sct->coDistY) )
	wsprintf(str,"NONE");
else
	wsprintf(str,"%hd,%hd",sct->coDistX, sct->coDistY); distPage.m_distxy = str;
wsprintf(str,"%d",(int)sct->ucTerr); distPage.m_terr = str;
wsprintf(str,"%hu",sct->unFdist); distPage.m_food = str;
wsprintf(str,"%hu",sct->unCdist); distPage.m_civs = str;
wsprintf(str,"%hu",sct->unMdist); distPage.m_mil = str;
wsprintf(str,"%hu",sct->unUdist); distPage.m_uws = str;
wsprintf(str,"%hu",sct->unIdist); distPage.m_iron = str;
wsprintf(str,"%hu",sct->unLdist); distPage.m_lcm = str;
wsprintf(str,"%hu",sct->unHdist); distPage.m_hcm = str;
wsprintf(str,"%hu",sct->unDdist); distPage.m_dust = str;
wsprintf(str,"%hu",sct->unOdist); distPage.m_oil = str;
wsprintf(str,"%hu",sct->unSdist); distPage.m_shells = str;
wsprintf(str,"%hu",sct->unGdist); distPage.m_guns = str;
wsprintf(str,"%hu",sct->unRdist); distPage.m_rads = str;
wsprintf(str,"%hu",sct->unBdist); distPage.m_bars = str;
wsprintf(str,"%hu",sct->unPdist); distPage.m_petrol = str;

// Set commPage data
wsprintf(str,"%d",(int)sct->ucTerr); commPage.m_terr = str;
wsprintf(str,"%hu",sct->unIron); commPage.m_iron = str;
wsprintf(str,"%hu",sct->unLcm); commPage.m_lcm = str;
wsprintf(str,"%hu",sct->unHcm); commPage.m_hcm = str;
wsprintf(str,"%hu",sct->unOil); commPage.m_oil = str;
wsprintf(str,"%hu",sct->unPetrol); commPage.m_petrol = str;
wsprintf(str,"%hu",sct->unFood); commPage.m_food = str;
wsprintf(str,"%hu",sct->unCiv); commPage.m_civs = str;
wsprintf(str,"%hu",sct->unMil); commPage.m_mil = str;
wsprintf(str,"%hu",sct->unGuns); commPage.m_guns = str;
wsprintf(str,"%hu",sct->unShells); commPage.m_shells = str;
wsprintf(str,"%hu",sct->unDust); commPage.m_dust = str;
wsprintf(str,"%hu",sct->unBars); commPage.m_bars = str;
wsprintf(str,"%hu",sct->unRads); commPage.m_rads = str;

// Set resPage data
wsprintf(str,"%d",(int)sct->ucTerr); resPage.m_terr = str;
wsprintf(str,"%d",(int)sct->ucMinContent); resPage.m_min = str;
wsprintf(str,"%d",(int)sct->ucFert); resPage.m_fert = str;
wsprintf(str,"%d",(int)sct->ucGoldContent); resPage.m_gold = str;
wsprintf(str,"%d",(int)sct->ucOilContent); resPage.m_oil = str;
wsprintf(str,"%d",(int)sct->ucUranContent); resPage.m_uran = str;
wsprintf(str,"%hu",sct->unCiv); resPage.m_civs = str;
wsprintf(str,"%d%%",(int)sct->ucEff); resPage.m_eff = str;
wsprintf(str,"%d",(int)sct->ucMob); resPage.m_mob = str;

// Set viewPage data
viewPage.m_bDesig = pDoc->mdoc_bShowMapChar;
viewPage.m_bDist = pDoc->mdoc_bShowDist;
viewPage.m_bShips = pDoc->mdoc_bShowShips;
viewPage.m_bPlanes = pDoc->mdoc_bShowPlanes;
viewPage.m_bLand = pDoc->mdoc_bShowLand;
viewPage.m_bNukes = pDoc->mdoc_bShowNukes;
viewPage.m_bMil = pDoc->mdoc_bShowMil;
viewPage.m_bHighlight = pDoc->mdoc_bShowHighlight;
viewPage.m_bRightBClose = pDoc->mdoc_bRightBClose;
viewPage.m_bPrintHexGrid = pDoc->mdoc_bPrintHexGrid;

// Set Ship data
s = "shp#     ship type       x,y   fl  eff civ mil  uw  fd pn he xl ln mob fuel tech";
shipPage.m_strArray.Add(s);
POSITION posS = pDoc->mdoc_ShipList.GetHeadPosition();
while( posS != NULL )
	{
	pship = (CEmpShip *)pDoc->mdoc_ShipList.GetNext( posS );
	if( (pship->coUserX == sct->coUserX) && (pship->coUserY == sct->coUserY) )
		cChar = '*';
	else
		cChar = ' ';
	wsprintf(str,"%c%4d %-16.16s %4d,%-4d %1c%4d%%%4d%4d%4d%4d%3d%3d%3d%3d%4d%5d%4d %s",
		cChar,
		(int)pship->unNum,
		(const char *)pship->sType,
		(int)pship->coUserX,
		(int)pship->coUserY,
		pship->ucMembership,
		(int)pship->ucEff,
		(int)pship->unCiv,
		(int)pship->unMil,
		(int)pship->unUW,
		(int)pship->unFood,
		(int)pship->ucPlanes,
		(int)pship->ucHelis,
		(int)pship->ucXlights,
		(int)pship->ucLands,
		(int)pship->ucMob,
		(int)pship->unFuel,
		(int)pship->unTech,
		(const char *)pship->sShipname);
	s = str;
	shipPage.m_strArray.Add(s);
	}


// Set Land data
s = "    # unit type             x,y   a  eff fort  mu food fuel tech retr rad xl ship";
landPage.m_strArray.Add(s);
POSITION posL = pDoc->mdoc_LandList.GetHeadPosition();	
while( posL != NULL )
	{
	pland = (CEmpLand *)pDoc->mdoc_LandList.GetNext( posL );
	if( (pland->coUserX == sct->coUserX) && (pland->coUserY == sct->coUserY) )
		cChar = '*';
	else
		cChar = ' ';
	wsprintf(str,"%c%4d %-16.16s   %4d,%-4d %1c%4d%%%5d%4d%5d%5d%5d %3d%%%4d%3d%5d",
		cChar,
		(int)pland->unNum,
		(const char *)pland->sType,
		(int)pland->coUserX,
		(int)pland->coUserY,
		pland->ucMembership,
		(int)pland->ucEff,
		(int)pland->ucFort,
		(int)pland->ucMob,
        (int)pland->unFood,
		(int)pland->unFuel,
		(int)pland->unTech,
		(int)pland->ucRetreat,
		(int)pland->ucRadius,
		(int)pland->ucXlights,
		(int)pland->unCarryShip);
	s = str;
	landPage.m_strArray.Add(s);
	}            

// Set Plane data
s = "   #    type                x,y    w  eff  mu att def tech ran hard   s/l L S nuke";
planePage.m_strArray.Add(s);
POSITION posP = pDoc->mdoc_PlaneList.GetHeadPosition();	
while( posP != NULL )
	{
	pplane = (CEmpPlane *)pDoc->mdoc_PlaneList.GetNext( posP );
	if( (pplane->coUserX == sct->coUserX) && (pplane->coUserY == sct->coUserY) )
		cChar = '*';
	else
		cChar = ' ';
	wsprintf(str,"%c%4d %-19.19s %4d,%-4d %c %3d%% %3d %3d %3d  %3d %3d  %3d%5d%c %c %c %d %s",
		cChar,
		(int)pplane->unNum,
		(const char *)pplane->sType,
		(int)pplane->coUserX,
		(int)pplane->coUserY,
		pplane->ucMembership,
		(int)pplane->ucEff,
		(int)pplane->ucMob,
        (int)pplane->ucAtt,
		(int)pplane->ucDef,
		(int)pplane->unTech,
		(int)pplane->ucRange,
		(int)pplane->ucHard,
		(int)pplane->unCarryUnit,
		pplane->ucCarryType,
		pplane->ucLaunched,
		pplane->ucSync,
		(int)pplane->ucNukeAmt,
		pplane->sNukeType);
	s = str;
	planePage.m_strArray.Add(s);
	}
	
// Set Nuke data

// Add pages into sheet
dlgPropertySheet.AddPage(&sectPage);
dlgPropertySheet.AddPage(&distPage);
dlgPropertySheet.AddPage(&commPage);
dlgPropertySheet.AddPage(&resPage);
dlgPropertySheet.AddPage(&viewPage);
dlgPropertySheet.AddPage(&nukePage);
dlgPropertySheet.AddPage(&shipPage);
dlgPropertySheet.AddPage(&planePage);
dlgPropertySheet.AddPage(&landPage);


if( dlgPropertySheet.DoModal() == IDOK )
	{
	// Get data changed on viewPage:
//	if( pDoc->mdoc_bShowMapChar != viewPage.m_bDesig )
//		mark them needing ucRedraw
	if( pDoc->mdoc_bShowMapChar != viewPage.m_bDesig )
		MarkSectWithDesig(pDoc);
	pDoc->mdoc_bShowMapChar = viewPage.m_bDesig;

	if( pDoc->mdoc_bShowDist != viewPage.m_bDist )	// if change was made
		MarkSectWithDist(pDoc);						// mark with ucRedraw
	pDoc->mdoc_bShowDist = viewPage.m_bDist;		// store setting
	
	if( pDoc->mdoc_bShowShips != viewPage.m_bShips )
		MarkSectWithShip(pDoc);
	pDoc->mdoc_bShowShips = viewPage.m_bShips;

	if( pDoc->mdoc_bShowPlanes != viewPage.m_bPlanes )
		MarkSectWithPlane(pDoc);	
	pDoc->mdoc_bShowPlanes = viewPage.m_bPlanes;

	if( pDoc->mdoc_bShowLand != viewPage.m_bLand )
		MarkSectWithLand(pDoc);	
	pDoc->mdoc_bShowLand = viewPage.m_bLand;

	if( pDoc->mdoc_bShowNukes != viewPage.m_bNukes )
		MarkSectWithNuke(pDoc);	
	pDoc->mdoc_bShowNukes = viewPage.m_bNukes;

	if( pDoc->mdoc_bShowMil != viewPage.m_bMil )
		MarkSectWithMil(pDoc);	
	pDoc->mdoc_bShowMil = viewPage.m_bMil;

	if( pDoc->mdoc_bShowHighlight != viewPage.m_bHighlight )
		MarkSectWithHighlight(pDoc);   
	pDoc->mdoc_bShowHighlight = viewPage.m_bHighlight;
	
	pDoc->mdoc_bRightBClose = viewPage.m_bRightBClose;
	pDoc->mdoc_bPrintHexGrid = viewPage.m_bPrintHexGrid;
		
	// SAMPLE: pDoc->data = sectPage.m_data;
	//pDoc->UpdateAllViews(NULL);
	pDoc->mdoc_bSpecialRedraw = TRUE;
	InvalidateRect(NULL, FALSE);
	}
	
CScrollView::OnLButtonDown(nFlags, point);
} // end of OnLButtonDown





void CMapView::OnViewDesignation()
{
CConnectDoc* pDoc = GetDocument();
if( pDoc->mdoc_bShowMapChar )
	pDoc->mdoc_bShowMapChar = FALSE;
else
	pDoc->mdoc_bShowMapChar = TRUE;
MarkSectWithDesig(pDoc);
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);
}

void CMapView::OnUpdateViewDesignation(CCmdUI* pCmdUI)
{
CConnectDoc* pDoc = GetDocument();
pCmdUI->SetCheck(pDoc->mdoc_bShowMapChar);	
}





void CMapView::OnViewDist()
{
CConnectDoc* pDoc = GetDocument();
if( pDoc->mdoc_bShowDist )
	pDoc->mdoc_bShowDist = FALSE;
else
	pDoc->mdoc_bShowDist = TRUE;	
MarkSectWithDist(pDoc);
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);
}

void CMapView::OnUpdateViewDist(CCmdUI* pCmdUI)
{
CConnectDoc* pDoc = GetDocument();
pCmdUI->SetCheck(pDoc->mdoc_bShowDist);	
}





void CMapView::OnViewHighlight()
{
CConnectDoc* pDoc = GetDocument();
if( pDoc->mdoc_bShowHighlight )
	pDoc->mdoc_bShowHighlight = FALSE;
else
	pDoc->mdoc_bShowHighlight = TRUE;
MarkSectWithHighlight(pDoc);
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);	
}

void CMapView::OnUpdateViewHighlight(CCmdUI* pCmdUI)
{
CConnectDoc* pDoc = GetDocument();
pCmdUI->SetCheck(pDoc->mdoc_bShowHighlight);	
}





void CMapView::OnViewLand()
{
CConnectDoc* pDoc = GetDocument();
if( pDoc->mdoc_bShowLand )
	pDoc->mdoc_bShowLand = FALSE;
else
	pDoc->mdoc_bShowLand = TRUE;
MarkSectWithLand(pDoc);
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);	
}

void CMapView::OnUpdateViewLand(CCmdUI* pCmdUI)
{
CConnectDoc* pDoc = GetDocument();
pCmdUI->SetCheck(pDoc->mdoc_bShowLand);
}
 
 
 
 
 
void CMapView::OnViewMil()
{
CConnectDoc* pDoc = GetDocument();
if( pDoc->mdoc_bShowMil )
	pDoc->mdoc_bShowMil = FALSE;
else
	pDoc->mdoc_bShowMil = TRUE;
MarkSectWithMil(pDoc);
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);		
}

void CMapView::OnUpdateViewMil(CCmdUI* pCmdUI)
{
CConnectDoc* pDoc = GetDocument();
pCmdUI->SetCheck(pDoc->mdoc_bShowMil);	
}





void CMapView::OnViewNuke()
{
CConnectDoc* pDoc = GetDocument();
if( pDoc->mdoc_bShowNukes )
	pDoc->mdoc_bShowNukes = FALSE;
else
	pDoc->mdoc_bShowNukes = TRUE;
MarkSectWithNuke(pDoc);
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);	
}

void CMapView::OnUpdateViewNuke(CCmdUI* pCmdUI)
{
CConnectDoc* pDoc = GetDocument();
pCmdUI->SetCheck(pDoc->mdoc_bShowNukes);	
}





void CMapView::OnViewPlane()
{
CConnectDoc* pDoc = GetDocument();
if( pDoc->mdoc_bShowPlanes )
	pDoc->mdoc_bShowPlanes = FALSE;
else
	pDoc->mdoc_bShowPlanes = TRUE;
MarkSectWithPlane(pDoc);
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);	
}

void CMapView::OnUpdateViewPlane(CCmdUI* pCmdUI)
{
CConnectDoc* pDoc = GetDocument();
pCmdUI->SetCheck(pDoc->mdoc_bShowPlanes);	
}





void CMapView::OnViewShip()
{
CConnectDoc* pDoc = GetDocument();
if( pDoc->mdoc_bShowShips )
	pDoc->mdoc_bShowShips = FALSE;
else
	pDoc->mdoc_bShowShips = TRUE;
MarkSectWithShip(pDoc);
pDoc->mdoc_bSpecialRedraw = TRUE;
InvalidateRect(NULL, FALSE);	
}

void CMapView::OnUpdateViewShip(CCmdUI* pCmdUI)
{
CConnectDoc* pDoc = GetDocument();
pCmdUI->SetCheck(pDoc->mdoc_bShowShips);	
}




void CMapView::OnUpdateExecute(CCmdUI* pCmdUI)
{
pCmdUI->Enable(FALSE);	
}

void CMapView::OnUpdateHistory(CCmdUI* pCmdUI)
{
pCmdUI->Enable(FALSE);	
}

void CMapView::OnUpdateRepeat(CCmdUI* pCmdUI)
{
pCmdUI->Enable(FALSE);	
}
