// mapview.h : interface of the CMapView class
//
/////////////////////////////////////////////////////////////////////////////
class CSectInfo;

class CMapView : public CScrollView
{
protected: // create from serialization only
	CMapView();
	DECLARE_DYNCREATE(CMapView)

// Attributes
public:
	CConnectDoc* GetDocument();
    CSectInfo *m_pDlg;
    CDC *pDispShipMemDC;
    CDC *pDispPlaneMemDC;
    CDC *pDispLandMemDC;
    CDC *pDispDistMemDC;
    CDC *pDispMilMemDC;
    
    CBitmap *pShipBitmap;
    CBitmap *pPlaneBitmap;
    CBitmap *pLandBitmap;
    CBitmap *pDistBitmap;
    CBitmap *pMilBitmap;
// Operations
public:

// Implementation
public:
	virtual ~CMapView();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	void CMapView::DrawHex(CDC* pDC, coord x, coord y, Cmap *sct, CBrush *hBrush, CBrush *hFontBrush, int ixColor, CPen *hPen);
	LONG OnSectInfo(UINT wParam, LONG lParam);
	LONG OnSectButton(UINT wParam, LONG lParam);
		
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void OnInitialUpdate(); // called first time after construct

	// Printing support
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo);	
	virtual void OnPrint(CDC* pDC, CPrintInfo*);

// Generated message map functions
protected:
	//{{AFX_MSG(CMapView)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnClearHighlight();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnViewDesignation();
	afx_msg void OnUpdateViewDesignation(CCmdUI* pCmdUI);
	afx_msg void OnViewDist();
	afx_msg void OnUpdateViewDist(CCmdUI* pCmdUI);
	afx_msg void OnViewHighlight();
	afx_msg void OnUpdateViewHighlight(CCmdUI* pCmdUI);
	afx_msg void OnViewLand();
	afx_msg void OnUpdateViewLand(CCmdUI* pCmdUI);
	afx_msg void OnViewMil();
	afx_msg void OnUpdateViewMil(CCmdUI* pCmdUI);
	afx_msg void OnViewNuke();
	afx_msg void OnUpdateViewNuke(CCmdUI* pCmdUI);
	afx_msg void OnViewPlane();
	afx_msg void OnUpdateViewPlane(CCmdUI* pCmdUI);
	afx_msg void OnViewShip();
	afx_msg void OnUpdateViewShip(CCmdUI* pCmdUI);
	afx_msg void OnUpdateExecute(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHistory(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRepeat(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in mapview.cpp
inline CConnectDoc* CMapView::GetDocument()
   { return (CConnectDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
