// wsempire.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "wsempire.h"

#include "mainfrm.h"
#include "conndoc.h"
#include "connvw.h"
#include "mapview.h"
#include "aboutbab.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
 
 
/////////////////////////////////////////////////////////////////////////////
// CWSempireApp

BEGIN_MESSAGE_MAP(CWSempireApp, CWinApp)
	//{{AFX_MSG_MAP(CWSempireApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(IDM_ABOUT_BABY, OnAboutBaby)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWSempireApp construction

CWSempireApp::CWSempireApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWSempireApp object

CWSempireApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CWSempireApp initialization

BOOL CWSempireApp::InitInstance()
{
UINT uiX, uiY, uiWidth, uiHeight;
WORD wVerReq = MAKEWORD(1,1);

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // Set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	uiX = GetProfileInt("MainWndProperties", "XPos", 0);
	uiY = GetProfileInt("MainWndProperties", "YPos", 0);
	uiWidth = GetProfileInt("MainWndProperties", "Width", 639);
	uiHeight = GetProfileInt("MainWndProperties", "Height", 479);	
	
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	//CMultiDocTemplate* pDocTemplate;
	pDocTemplateC = new CMultiDocTemplate(
		IDR_EMPCONTYPE,
		RUNTIME_CLASS(CConnectDoc),
		RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
		RUNTIME_CLASS(CConnectView));
	AddDocTemplate(pDocTemplateC);

    	pDocTemplateM = new CMultiDocTemplate(
		IDR_EMPMAPTYPE,
		RUNTIME_CLASS(CConnectDoc),
		RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
		RUNTIME_CLASS(CMapView));


	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;
    m_pMainWnd->SetWindowPos(NULL, uiX, uiY, uiWidth, uiHeight, SWP_NOZORDER);

	// enable file manager drag/drop and DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes();
	
    m_bWinSockOK = FALSE;
    m_nWinSockError = 0;
    if( WSAStartup(wVerReq, &m_wsaData) == 0 )
    	{
    	if( wVerReq == m_wsaData.wVersion)
    		m_bWinSockOK = TRUE;
    	}
    else
    	{
    	m_nWinSockError = WSAGetLastError();
	   	}
    	
	// simple command line parsing
	if (m_lpCmdLine[0] == '\0')
	{
		// create a new (empty) document
		// OnFileNew();
	}
	else
	{
		// open an existing document
		OpenDocumentFile(m_lpCmdLine);
	}

	m_pMainWnd->DragAcceptFiles();
	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

#ifdef SHIT	
	BOOL maxed;
	CMDIChildWnd *pActiveChild = pMainFrame->MDIGetActive(&maxed);
	if( !maxed )
		pActiveChild->MDIMaximize();
#endif
    
    OnAppAbout();
    
	return TRUE;
}
 
 

int CWSempireApp::ExitInstance()
{
if( m_bWinSockOK )
	WSACleanup();
delete pDocTemplateC;
delete pDocTemplateM;
return CWinApp::ExitInstance();
}



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CWSempireApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CWSempireApp commands

void ErrorBox(CString msg, UINT uiCode)
{                       
CString s;
UINT uiWSACode;

if( (uiCode > 0) && (uiCode < WSABASEERR) )
	{
	s.LoadString(uiCode);
	msg = msg + "\n" + s;
	}
if( (uiCode > 0) && (uiCode > WSABASEERR) )
	{
	s = "";
	uiWSACode = 0;
	switch( uiCode )
		{
		case WSAEINTR:			uiWSACode = IDS_WSAEINTR; break;
		case WSAEBADF:			uiWSACode = IDS_WSAEBADF; break;
		case WSAEACCES:			uiWSACode = IDS_WSAEACCES; break;
		case WSAEFAULT:			uiWSACode = IDS_WSAEFAULT; break;		
		case WSAEINVAL:			uiWSACode = IDS_WSAEINVAL; break;
		case WSAEMFILE:			uiWSACode = IDS_WSAEMFILE; break;
		case WSAEWOULDBLOCK:	uiWSACode = IDS_WSAEWOULDBLOCK; break;						
		case WSAEINPROGRESS:	uiWSACode = IDS_WSAEINPROGRESS; break;		
		case WSAEALREADY:		uiWSACode = IDS_WSAEALREADY; break;		
		case WSAENOTSOCK:		uiWSACode = IDS_WSAENOTSOCK; break;		
		case WSAEDESTADDRREQ:	uiWSACode = IDS_WSAEDESTADDRREQ; break;		
		case WSAEMSGSIZE:		uiWSACode = IDS_WSAEMSGSIZE; break;		
		case WSAEPROTOTYPE:		uiWSACode = IDS_WSAEPROTOTYPE; break;		
		case WSAENOPROTOOPT:	uiWSACode = IDS_WSAENOPROTOOPT; break;		
		case WSAEPROTONOSUPPORT: uiWSACode = IDS_WSAEPROTONOSUPPORT; break;		
		case WSAESOCKTNOSUPPORT: uiWSACode = IDS_WSAESOCKTNOSUPPORT; break;		
		case WSAEOPNOTSUPP:		uiWSACode = IDS_WSAEOPNOTSUPP; break;		
		case WSAEPFNOSUPPORT:	uiWSACode = IDS_WSAEPFNOSUPPORT; break;		
		case WSAEAFNOSUPPORT:	uiWSACode = IDS_WSAEAFNOSUPPORT; break;		
		case WSAEADDRINUSE:		uiWSACode = IDS_WSAEADDRINUSE; break;		
		case WSAEADDRNOTAVAIL:	uiWSACode = IDS_WSAEADDRNOTAVAIL; break;		
		case WSAENETDOWN:		uiWSACode = IDS_WSAENETDOWN; break;		
		case WSAENETUNREACH:	uiWSACode = IDS_WSAENETUNREACH; break;		
		case WSAENETRESET:		uiWSACode = IDS_WSAENETRESET; break;		
		case WSAECONNABORTED:	uiWSACode = IDS_WSAECONNABORTED; break;				
		case WSAECONNRESET:		uiWSACode = IDS_WSAECONNRESET; break;
		case WSAENOBUFS:		uiWSACode = IDS_WSAENOBUFS; break;
		case WSAEISCONN:		uiWSACode = IDS_WSAEISCONN; break;
		case WSAENOTCONN:		uiWSACode = IDS_WSAENOTCONN; break;
		case WSAESHUTDOWN:		uiWSACode = IDS_WSAESHUTDOWN; break;
		case WSAETOOMANYREFS:	uiWSACode = IDS_WSAETOOMANYREFS; break;
        case WSAETIMEDOUT:		uiWSACode = IDS_WSAETIMEDOUT; break;
		case WSAECONNREFUSED:	uiWSACode = IDS_WSAECONNREFUSED; break;
		case WSAELOOP:			uiWSACode = IDS_WSAELOOP; break;
		case WSAENAMETOOLONG:	uiWSACode = IDS_WSAENAMETOOLONG; break;
		case WSAEHOSTDOWN:		uiWSACode = IDS_WSAEHOSTDOWN; break;
		case WSAEHOSTUNREACH:	uiWSACode = IDS_WSAEHOSTUNREACH; break;
		case WSAENOTEMPTY:		uiWSACode = IDS_WSAENOTEMPTY; break;
		case WSAEPROCLIM:		uiWSACode = IDS_WSAEPROCLIM; break;
		case WSAEUSERS:			uiWSACode = IDS_WSAEUSERS; break;
		case WSAEDQUOT:			uiWSACode = IDS_WSAEDQUOT; break;
		case WSAESTALE:			uiWSACode = IDS_WSAESTALE; break;
		case WSAEREMOTE:		uiWSACode = IDS_WSAEREMOTE; break;
		case WSASYSNOTREADY:	uiWSACode = IDS_WSASYSNOTREADY; break;
		case WSAVERNOTSUPPORTED: uiWSACode = IDS_WSAVERNOTSUPPORTED; break;
		case WSANOTINITIALISED:	uiWSACode = IDS_WSANOTINITIALISED; break;
		case WSAEDISCON:		uiWSACode = IDS_WSAEDISCON; break;
		case WSAHOST_NOT_FOUND:	uiWSACode = IDS_WSAHOST_NOT_FOUND; break;
		case WSATRY_AGAIN:		uiWSACode = IDS_WSATRY_AGAIN; break;		
		case WSANO_RECOVERY:	uiWSACode = IDS_WSANO_RECOVERY; break;		
		case WSANO_DATA:		uiWSACode = IDS_WSANO_DATA; break;		
		default:
			uiWSACode = IDS_WSAE_NO_STRINGTABLE_MATCH;
			break;
		}
	s.LoadString(uiWSACode);
	msg = msg + "\n" + s;
	}	
AfxMessageBox(msg);
}                     

void CWSempireApp::OnAboutBaby()
{
	CAboutBaby aboutBabyDlg;
	aboutBabyDlg.DoModal();	
}
